/*
  Copyright 2009,2014
  John Culp, All Rights Reserved
*/

#include <stdlib.h>

#include "Line.hh"

using namespace std;

Line::Line(void) :
  num(0), lt(LT_UNKNOWN), address(0), org_address(0), seg_increment(1)
{}

Line::Line(const Line &rhs) :
  lineBuffer(rhs.lineBuffer),
  num(rhs.num),
  lt(rhs.lt),

  insn(rhs.insn), argA(rhs.argA), argB(rhs.argB), argC(rhs.argC),

  label(rhs.label), address(rhs.address),

  org_address(rhs.org_address),
  seg_name(rhs.seg_name),
  seg_increment(rhs.seg_increment)
{}

Line::~Line(void)
{}

const Line& Line::operator=(const Line &rhs)
{
  lineBuffer = rhs.lineBuffer;
  num = rhs.num;

  lt = rhs.lt;

  insn = rhs.insn;
  argA = rhs.argA;
  argB = rhs.argB;
  argC = rhs.argC;

  label = rhs.label;
  address = rhs.address;

  org_address = rhs.org_address;
  seg_name = rhs.seg_name;
  seg_increment = rhs.seg_increment;

  return rhs;
}

bool Line::Blank(void)
{
  for(unsigned ii = 0; ii < lineBuffer.size(); ii++ )
    if( !isspace( lineBuffer[ii] ) ) return false;

  return true;
}

void Line::ToCaps(std::string &rStr)
{
  for(unsigned ii = 0; ii < rStr.size(); ii++)
    {
      if( isalpha( rStr[ii] ) )
	rStr[ii] = toupper( rStr[ii] );
    };
}
