/*
  Copyright 2009,2014
  John Culp, All Rights Reserved
*/

#ifndef LINE_INCLUDED
#define LINE_INCLUDED

#include <string>

class Line
{
public:
  Line(void);
  Line(const Line &rhs);
  ~Line(void);

  const Line& operator=(const Line &rhs);

  bool Blank(void);
  void ToCaps(std::string &rStr);

  std::string lineBuffer;
  //std::string fileName; //for include
  unsigned num;

  enum LT{LT_INSN, LT_INSN_MACRO, LT_LABEL, LT_ORG, LT_SEGMENT, LT_SEGMENT_END, LT_UNKNOWN};
  LT lt;

  //copies, but who cares.
  std::string insn;
  std::string argA;
  std::string argB;
  std::string argC;

  //if the line is a label
  std::string label;
  long address; //used for an instruction too.

  //if the line is an org
  long org_address;

  //if the line is a segment
  std::string seg_name;
  long seg_increment;
};

#endif //LINE_INCLUDED
