/*
  Copyright 2014
  John Culp, All Rights Reserved
*/

#ifndef FULLOPPLIST_INCLUDED
#define FULLOPPLIST_INCLUDED

#include <list>

#include "ExecState.hh"
#include "PT_State.hh"
#include "ID_Gen.hh"
#include "VarStack.hh"

class Opp;

class FullOppList
{
public:
  FullOppList(void);
  FullOppList(const Opp &rOpp);
  FullOppList(const FullOppList &rhs);
  virtual ~FullOppList(void);

  const FullOppList& operator=(const FullOppList &rhs);

  void AddStatement(const Opp &rOpp);

  virtual void Exec(ExecState &rState);

  void PrintTree(unsigned prevID, PT_State &rPTS);
  virtual void AssignUniqueIDs(ID_Gen &rGen);
  virtual void PushVarTypes(VarStack &rDefs);

  //for certain opps (like if/while/for) the stores
  //must go to special names (hackish?)
  void AssignProperName(const std::string &rName);
  void DebugTestProperName(void);

  std::list<Opp*> opps;

protected:
  virtual void Clear(void);
};

#endif //FULLOPPLIST_INCLUDED
