/*
  Copyright 2014
  John Culp, All Rights Reserved
*/

#include <iostream>

#include "ID_Gen.hh"

using namespace std;

ID_Gen::ID_Gen(void) :
  next_id(0), next_ct_id(0)
{}

ID_Gen::ID_Gen(const ID_Gen &rhs) :
  next_id(rhs.next_id), next_ct_id(rhs.next_ct_id)
{}

ID_Gen::~ID_Gen(void)
{}

const ID_Gen& ID_Gen::operator=(const ID_Gen &rhs)
{
  next_id = rhs.next_id;
  next_ct_id = rhs.next_ct_id;

  return *this;
}

void ID_Gen::Reset(void)
{
  next_id = 0;
  next_ct_id = 0;
}

unsigned ID_Gen::GetID(void)
{
  return next_id++;
}

unsigned ID_Gen::GetCTID(void)
{
  return next_ct_id++;
}
