/*
  Copyright 2010,2014
  John Culp, All Rights Reserved
*/

#ifndef IE_CALL_INCLUDED
#define IE_CALL_INCLUDED

#include "IExpr.hh"

class CallArg : public FullOppList
{
public:
  CallArg(void);
  CallArg(const IE &rIE);
  CallArg(const CallArg &rhs);
  virtual ~CallArg(void);

  const CallArg& operator=(const CallArg &rhs);

  //each argument has its own compiler temp
  unsigned ctID;
};

class ExprList
{
public:
  ExprList(void);
  ExprList(const IE &rIE);
  ExprList(const ExprList &rhs);
  ~ExprList(void);

  void AddIE(const IE &rIE);

  const ExprList& operator=(const ExprList&rhs);

  void Clear(void);

  std::list<CallArg> exprList;
};

class IE_Call : public IE //function call
{
public:
  IE_Call(const std::string &rFnName);
  IE_Call(const std::string &rFnName, ExprList &rEL);
  IE_Call(const IE_Call &rhs);
  virtual ~IE_Call(void);

  virtual IE* Clone(void) const;
  virtual void GetGName(std::string &rName);
  virtual DTYPE Exec(ExecState &rState);
  virtual void PrintTree(unsigned myID, PT_State &rPTS);
  virtual void AssignUniqueIDs(ID_Gen &rGen);
  virtual void PushVarTypes(VarStack &rDefs);
  virtual P_TYPE GetType(void);

  unsigned ct_id; //temporary for my return value.

  std::string functionName;
  ExprList exprList;

private:
  const IE_Call& operator=(const IE_Call &rhs);
};



#endif //IE_CALL_INCLUDED
