/*
  Copyright 2014
  John Culp, All Rights Reserved
*/

#include <iostream>
using namespace std;

#include "TVCC_Parser_Objs.hh"

ParamDecl::ParamDecl(void) :
  size(1)
{
  //cout << "ParamDecl::ParamDecl" << endl;
}

ParamDecl::ParamDecl(const ParamDecl &rhs) :
  type(rhs.type), name(rhs.name), size(rhs.size)
{
  //cout << "ParamDecl::ParamDecl copy constructor" << endl;
}

ParamDecl::ParamDecl(P_TYPE ttype, const std::string &rName) :
  type(ttype), name(rName), size(1)
{
  //cout << "ParamDecl::ParamDecl specified constructor" << endl;
}

ParamDecl::ParamDecl(P_TYPE ttype, const std::string &rName, int tsize) :
  type(ttype), name(rName), size(tsize)
{}

ParamDecl::~ParamDecl(void)
{
  //cout << "ParamDecl::~ParamDecl" << endl;
}
  
const ParamDecl& ParamDecl::operator=(const ParamDecl &rhs)
{
  type = rhs.type;
  name = rhs.name;
  size = rhs.size;

  return *this;
}

std::string ParamDecl::Translate(P_TYPE ptype)
{
  switch(ptype)
    {
    case P_UINT:
      return string("UINT");
    case P_SINT:
      return string("P_SINT");
    case P_FLOAT:
      return string("P_FLOAT");
    default:
      return string("unknown");
    };
}


// ***************

ParamDeclList::ParamDeclList(void)
{
  cout << "ParamDeclList::ParamDeclList" << endl;
}

ParamDeclList::ParamDeclList(const ParamDecl &rhs)
{
  paramList.push_back(rhs);
  cout << "ParamDeclList::ParamDeclList via decl" << endl;
}

ParamDeclList::ParamDeclList(const ParamDeclList &rhs) :
  paramList(rhs.paramList)
{
  cout << "ParamDeclList::ParamDeclList copy constructor" << endl;
}

ParamDeclList::~ParamDeclList(void)
{
  cout << "ParamDeclList::~ParamDeclList" << endl;  
}

const ParamDeclList& ParamDeclList::operator=(const ParamDeclList &rhs)
{
  paramList = rhs.paramList;
  
  return *this;
}

void ParamDeclList::AddDecl(const ParamDecl &rhs)
{
  paramList.push_back(rhs);
}
