/*
  Copyright 2014
  John Culp, All Rights Reserved
*/

#ifndef TVCC_PARSER_OBJS
#define TVCC_PARSER_OBJS

#include <string>
#include <list>

#include "Opps.hh"
#include "TVCC_Defs.hh"

class ParamDecl
{
public:
  ParamDecl(void);
  ParamDecl(const ParamDecl &rhs);
  ParamDecl(P_TYPE ttype, const std::string &rName);
  ParamDecl(P_TYPE ttype, const std::string &rName, int tsize);
  ~ParamDecl(void);
  
  const ParamDecl& operator=(const ParamDecl &rhs);

  static std::string Translate(P_TYPE ptype);

  P_TYPE type;
  std::string name;
  int size;
};

class ParamDeclList
{
public:
  ParamDeclList(void);
  ParamDeclList(const ParamDecl &rhs);
  ParamDeclList(const ParamDeclList &rhs);
  ~ParamDeclList(void);

  const ParamDeclList& operator=(const ParamDeclList &rhs);

  void AddDecl(const ParamDecl &rhs);

  std::list<ParamDecl> paramList;
};

#endif //TVCC_PARSER_OBJS
