/*
  Copyright 2010,2014
  John Culp, All Rights Reserved
*/

#include <fstream>
#include <stdlib.h>
#include <iostream>

#include "Sim.hh"

using namespace std;

Sim::Sim(void) :
  CPU(), fb(2000000)
{}

Sim::~Sim(void)
{}

void Sim::SetupForExec(void)
{
  PC = 0;
}

void Sim::GetState(unsigned &rPC, unsigned &rA, unsigned &rB, unsigned &rC, unsigned &rD,
		   unsigned &rE, unsigned &rF, unsigned &rG, unsigned &rH)
{
  rPC = PC;
  rA = regA;
  rB = regB;
  rC = regC;
  rD = regD;
  rE = regE;
  rF = regF;
  rG = regG;
  rH = regH;
}

unsigned long Sim::GetData(unsigned dword)
{
  if( dword >= data_ram.size() ) return 0;

  return data_ram[dword];
}

void Sim::SetData(unsigned dword, unsigned value)
{
  if(dword >= data_ram.size() ) return;

  data_ram[dword] = value;
}

unsigned long Sim::GetProg(unsigned dword)
{
  if( dword >= program_rom.size() ) return 0xF00F0FF0;

  return program_rom[dword];
}

unsigned long Sim::GetPC(void)
{
  return PC;
}

void Sim::BlankFB(void)
{
  for(unsigned ii = 0; ii < fb.size(); ii++)
    fb[ii] = 0;
}

void Sim::DoDMA(REG_TYPE localAddr, REG_TYPE fbAddr, unsigned count, bool toFB)
{
  cout << "Sim::DoDMA localAddr: " << localAddr << " fbAddr: " << fbAddr << " count: " << count << " toFB: " << toFB << endl;
  if( ( (fbAddr+count) > fb.size()) || ( (localAddr+count) > data_ram.size()) )
    {
      cout << "IGNOREING INVALID DMA REQUEST" << endl;
      return;
    };

  for(unsigned ii = 0; ii < count; ii++)
    {
      if(toFB)
	{
	  fb[fbAddr + ii] = data_ram[localAddr+ii];
	  dmaToFBOccurred = true;
	}else
	{
	  data_ram[localAddr+ii] = fb[fbAddr + ii];
	};
    };
}
