/*
  Copyright 2010,2014
  John Culp, All Rights Reserved
*/

#ifndef SIM_INCLUDED
#define SIM_INCLUDED

#include <string>
#include <vector>

#include "cpu.hh"

class Sim : public CPU
{
public:
  Sim(void);
  ~Sim(void);

  void SetupForExec(void);

  void GetState(unsigned &rPC, unsigned &rA, unsigned &rB, unsigned &rC, unsigned &rD,
		unsigned &rE, unsigned &rF, unsigned &rG, unsigned &rH);
  unsigned long GetData(unsigned dword);
  void SetData(unsigned dword, unsigned value);

  unsigned long GetProg(unsigned dword);

  unsigned long GetPC(void);

  void BlankFB(void);
  std::vector<unsigned> fb; //8MB in size

  bool dmaToFBOccurred;
protected:

  virtual void DoDMA(REG_TYPE localAddr, REG_TYPE fbAddr, unsigned count, bool toFB);
};

#endif //SIM_INCLUDED
