/*
  Copyright 2009
  John Culp, All Rights Reserved
*/

#include <iostream>

#include <libGx/GxMainInterface.hh>
#include <libGx/GxDisplay.hh>

#include "SimGui.hh"
#include "Sim.hh"

using namespace std;

int main(int argc, char **argv)
{
  GxMainInterface mainInt("TVC sim", 0);
  if( !mainInt.Initialize(argc, argv) )
    {
      cerr << "failed to open display" << endl;
      return -1;
    };

  if( !mainInt.OpenAllocateAll() ) return -2;

  Sim sim;

  SimGui simGui( mainInt.dispVector[0], sim );

  simGui.Place();
  simGui.Create();
  simGui.Display();

  mainInt.EventLoop();

  return 0;
};
