.segment data_1
.org 0
startX

.org 1
startZ

.org 2
endX

.org 3
endZ

.org 4
yValue

.org 5
texStartX

.org 6
texStartY

.org 7
texIncX

.org 8
texIncY

.org 9
pixValueIn

.org 10
zInc

.org 11
buffWidth

.org 12
pixBuffer

.org 13
depthBuffer

.org 14
pixDMA

.org 22
depthDMA

	;; little extra space
.org 32
cPixStart

.org 33
cDepthStart

.org 34
remainingPixels

.org 35
intervalPixels

.org 36
cPix

.org 37
cZ

.org 38
save_needed			;a z buffer or front buffer value was changed
	
.org 504
dma0_fb_addr
.org 505
dma0_sd_addr
.org 506
dma1_fb_addr
.org 507
dma1_sd_addr
.org 508
dma2_fb_addr
.org 509
dma2_sd_addr
.org 510
dma3_fb_addr
.org 511
dma3_sd_addr
.org 512
dma_cmd

	
.segment program
.org 0
	;; compute the scanline pixel and depthbuffer start address
	;; pixStart = pixBuffer + 4*(buffWidth*yValue + startX)
	;; dbStart = depthBuffer + 4*(buffWidth*yValue + startX)
	;; start the dma into buffer
	LRI %A startZ		
	SRI %A cZ
	LRI %A buffWidth
	LRI %B yValue
	MUL %A %B %A		;A holds buffWidth*yValue
	LRI %B startX
	ADD %A %B %A		;A holds startX + buffWidth*yValue
	LRI %B pixBuffer
	ADD %A %B %C		;now C holds correct pix start addresss for scanline
	SRI %C cPixStart
	LRI %B depthBuffer
	ADD %A %B %C		;now c holds correct depth start address for scanline
	SRI %C cDepthStart
	;; compute number of pixels to examine this scanline
	LRI %A startX
	LRI %B endX
	SUB %B %A %B
	SRI %B remainingPixels		;number to process
setup_for_interval			;note remainingPixels are in B
	LI %A 0
	SRI %A cPix
	SRI %A save_needed
	LLI %A 8
	;; LUI %A 0
	CMP %A %B %C		;if 8 > remainingPixels, set the greater than flag
	SBCLR %C 1		;if gt flag set then use remaining (8 is too many)
	JI use_remaining
	SRI %A intervalPixels	; use 8 pixels for interval
	JI dma_in_start
use_remaining
	SRI %B intervalPixels
dma_in_start
	;; dma in pixel and depth buffer
	LRI %A cPixStart
	SRI %A dma0_fb_addr
	LRI %A cDepthStart
	SRI %A dma1_fb_addr
	LRI %A intervalPixels
	RSL %A %A 16 		; put num dword transfers in correct bits
	BSET %A %A 31		; set the read bit
	LLI %B pixDMA 		;hackish, but we know address are < 65535
	LUI %B 0
	OR %A %B %B
	SRI %B dma0_sd_addr
	LLI %B depthDMA 	;hackish, but we know address are < 65535
	LUI %B 0
	OR %A %B %B
	SRI %B dma1_sd_addr
	LI %C 2
	SRI %C dma_cmd 		;trigger 2 dma xfers
	NOP			;probably at least one needed
	NOP
dma_in_wait
	LRI %C dma_cmd
	SEQZ %C
	JI dma_in_wait
proc_interval			;if here we will process at least one pixel
	LRI %A cZ		;A holds cZ
	LRI %B cPix
	LLI %C depthDMA
	LUI %C 0
	ADD %B %C %C	  	;c now holds the address within the depth dma buffer of the current pixels Z
	LRR %C %C 0		;load the current pixel's depth value into C
	CMP %A %C %C		;results of cZ > depthBufferZ is in C
	SBCLR %C 4		; if >
	JI no_update
do_update
	;; update the pix buffer and the depth buffer
	LLI %C 65535		;juse a non-zero value
	SRI %C save_needed
	LLI %C depthDMA
	LUI %C 0
	ADD %B %C %C
	SRR %A %C 0		;the new depth is stored in local buffer
	LRI %A pixValueIn
	SRI %A pixDMA
	LLI %C pixDMA
	LUI %C 0
	ADD %B %C %C
	SRR %A %C 0			; the new pixel buffer is stored in local buffer (ERROR)
no_update
	LLI %C 65535		;juse a non-zero value
	SRI %C save_needed	
	;; update cZ
	LRI %A cZ
	LRI %B zInc
	ADD %A %B %A
	SRI %A cZ
	;; increment cPix
	LRI %A cPix
	ADDL %A %A 1
	SRI %A cPix
	;; see if have more pixels to process on this interval
	LRI %B intervalPixels
	CMP %A %B %A
	SBCLR %A 0 		; if cPix != intervalpixels, bit 0 is clear, so we should continue
	JI interval_done
	JI proc_interval
interval_done
	;; see if we need to actually do the dma
	LRI %A save_needed
	SEQZ %A
	JI do_dma
	JI dma_out_done
do_dma
	;; dma the results out. the addresses are already configured, just change the direction bits
	LRI %B dma0_sd_addr
	BCLR %B %B 31		;clear the read bit for xfer 1
	SRI %B dma0_sd_addr
	LRI %B dma1_sd_addr
	BCLR %B %B 31		;clear the read bit for xfer 1
	SRI %B dma1_sd_addr
	LI %C 2
	SRI %C dma_cmd 		;trigger 2 dma xfers
	NOP			;probably at least one needed
	NOP
dma_out_wait
	LRI %C dma_cmd
	SEQZ %C
	JI dma_out_wait
	;; done with dma out
dma_out_done
	LRI %A intervalPixels
	LRI %B cPixStart
	ADD %A %B %B
	SRI %B cPixStart
	LRI %B cDepthStart
	ADD %A %B %B
	SRI %B cDepthStart
	LRI %A remainingPixels
	LRI %B intervalPixels
	SUB %A %B %B
	SRI %B remainingPixels
	SEQZ %B
	JI setup_for_interval	; note that we have left remainining pixels in register B
done
	HLT

really_done
