/*
  file created 2014
  modified
  released to the Public Domain by the author
*/

#ifndef TVCDRIVER_INCLUDED
#define TVCDRIVER_INCLUDED

#include <vector>

#include "EPPPort.hh"
#include "CB_Base.hh"

/*
  this has not been tested, just quick hacked on to compile
  probably does not work
*/

class CB_EPP : public CB_Base
{
public:
  CB_EPP(EPPPort &rTPort);
  virtual ~CB_EPP(void);

  void DumpRegisters(void); //does not use cache
  void DumpLocalRegisterCache(void);
  void ClearRegisters(void); //does not use cache
  void PrintStatus(void); //does not use cache

  // ********* start CB_Base overloads ********* 
  virtual void CB_Write(unsigned addr, unsigned value);
  virtual unsigned CB_Read(unsigned addr);
  //not implemented 
  //virtual void CB_Wait_Equ(unsigned addr, unsigned value);
  // ********* end CB_Base overloads ********* 

protected:
  //force a write to all registers to sync up local and remote
  void DirtyRegisterCache(void);

  //we cache the remote contents of the data registers so we only write the
  //registers that have changed.
  void FlushRegisters(void);
  std::vector<unsigned char> localDataRegisters;
  std::vector<unsigned char> remoteDataRegisters;
  std::vector<bool> remoteDataValid;
  //unsigned char remoteAddress; we don't cache this right now.
  void Write32(unsigned long value, unsigned regOffset); //writes into the cache.

  EPPPort &rPort;
};

#endif //TVCDRIVER_INCLUDED
