/*
  file created 2014
  modified
  released to the Public Domain by the author
*/

#ifndef CB_SIMSHIM_INCLUDED
#define CB_SIMSHIM_INCLUDED

#include "CB_Base.hh"
#include "ShimXShaderCPU.hh"

//enough of a model of the command bus to run a simulated shader processor.

#include <stdint.h>
typedef uint32_t reg_t;

class CB_SimShim : public CB_Base, protected ShimXShaderCPU
{
public:
  CB_SimShim(void);
  virtual ~CB_SimShim(void);

  virtual void CB_Write(unsigned addr, unsigned value);
  virtual unsigned CB_Read(unsigned addr);
  virtual void CB_Wait_Equ(unsigned addr, unsigned value);

protected:

  void DoBlockRead(void);
  void DoBlockWrite(void);
  void DoBlockSet(reg_t pix_value);

  reg_t reg_01;
  reg_t reg_02;

  reg_t reg_11;
  reg_t reg_12;

  reg_t reg_21;
  reg_t reg_22;

  reg_t reg_e0;
  reg_t reg_e1;
};

#endif //CB_SIMSHIM_INCLUDED
