/*
  file created 2014
  modified
  released to the Public Domain by the author
*/

#ifndef CB_USB_INCLUDED
#define CB_USB_INCLUDED

#include <string.h>
#include <libusb-1.0/libusb.h>

#include "CB_Base.hh"

const unsigned CMD_WR = 0xF0;
const unsigned CMD_RD = 0x0F;

class CB_USB : public CB_Base
{
public:
  CB_USB(void);
  virtual ~CB_USB(void);

  void Init(void);

  void Test(void);

  virtual void CB_Write(unsigned addr, unsigned value);
  virtual unsigned CB_Read(unsigned addr);

protected:
  inline void BuildWriteBuffer(unsigned cmd, unsigned addr, unsigned value, unsigned char wb[8])
  {
    wb[0] = 0xAA;
    wb[1] = cmd;
    wb[2] = addr;
    memcpy(wb+3, &value, 4);
    wb[7] = 0xFF;
  }

  unsigned Read_LL(void);

  struct libusb_context  *lusb_context;
  struct libusb_device_handle *usb_handle;
};

#endif //CB_USB_INCLUDED
