/*
  file created 2014
  modified
  released to the Public Domain by the author
*/

#include <iostream>
#include <assert.h>

#include "CB_USB_Buffered.hh"

const unsigned BUF_MAX = 512;

using namespace std;

CB_USB_Buffered::CB_USB_Buffered(void) :
  wb_end(0), writes_combined(0)
{}

CB_USB_Buffered::~CB_USB_Buffered(void)
{}

void CB_USB_Buffered::CB_Write(unsigned addr, unsigned value)
{
#if 0
  cout << "CB_USB_Buffered::CB_Write addr: "
       << hex << addr << " value: " << value << dec << endl;
#endif

  unsigned char out_buff[8];
  BuildWriteBuffer(CMD_WR, addr, value, out_buff);
  AddWriteToBuffer(out_buff); //might flush then add
 }

unsigned CB_USB_Buffered::CB_Read(unsigned addr)
{
  unsigned char out_buff[8];
  BuildWriteBuffer(CMD_RD, addr, 0, out_buff);
  AddWriteToBuffer(out_buff); //might flush then add
  Flush(); //icky if happens twice.

  return Read_LL();
}

void CB_USB_Buffered::AddWriteToBuffer(unsigned char buff[8])
{
 if(wb_end + 8 > BUF_MAX) Flush(); //flush would reset wb_end

  memcpy(write_buffer + wb_end, buff, 8);
  wb_end += 8;
  writes_combined++;
}

void CB_USB_Buffered::Flush(void)
{
  if(!wb_end) return;

#if 0
  cout << "CB_USB_Buffered::Flush combined writes: " << writes_combined << endl;
#endif

  writes_combined = 0;

  int xfer = 0;
  int ret = libusb_bulk_transfer(usb_handle, 0x02, write_buffer, wb_end, &xfer, 100);
#if 0
  cout << "CB_USB_Buffered::Flush write got ret: " << ret << endl;
#endif

  if( ret != 0 || xfer != wb_end)
    {
      cout << "write failure in CB_USB_Buffered::Flush" << endl;
      cout << "ret: " << ret << " xfer: " << xfer << " wb_end: " << wb_end << endl;
      assert(false);
    };

  wb_end = 0;
}

