/*
  file created 2006
  modified
  released to the Public Domain by the author
*/

#ifndef EPPPORT_INCLUDED
#define EPPPORT_INCLUDED

class EPPPort
{
public:
  EPPPort(void);
  ~EPPPort(void);

  void SetStatusCheck(bool tscStat); //done by default
  void SetAbortOnError(bool tabError); //done by default

  bool Initialize(void);
  bool CloseAll(void);

  bool TestDataLinkQuality(void); //returns false if any problem

  //if returns true there was a timeout
  bool CheckAndClearTimeout(void);

  //these are epp addresses - the control bus is a layer above.
  void WriteAddress(unsigned char address);
  void WriteData(unsigned char data);
  void ReadData(unsigned char &rData);

protected:
  bool scStat;
  bool abError;
};

#endif //EPPPORT_INCLUDED
