/*
  file created 2014
  released to the Public Domain by the author
*/

#ifndef ENGINEBASE_INCLUDED
#define ENGINEBASE_INCLUDED

#include "TCoord.hh"
#include "TForm.hh"
#include "Texture.hh"

class EngineBase
{
public:
  EngineBase(void);
  virtual ~EngineBase(void);

  //call before anything and after transform changes...
  //meaning is changing though. exists for sake of hardware.
  virtual void Setup(void) = 0;
  virtual void TriFace(TCoord rC1, TCoord rC2, TCoord rC3,
		       TexC t1, TexC t2, TexC t3) = 0;

  virtual void ClearFB(void) = 0;
  virtual void ClearDB(void) = 0;
  virtual void UpLoadTexture(Texture &rTexture, unsigned textureID) = 0;
  virtual void SetCTexture(unsigned cTextureID) = 0;
  virtual void Flush(void) = 0;

  virtual void PushTForm(TForm addTForm) = 0;
  virtual void ClearTForm(void) = 0; //sets to identity
};

#endif //ENGINEBASE_INCLUDED
