/*
  file created 2014
  from files created & modified in 2006 and 2009
  released to the Public Domain by the author
*/

#ifndef ENGINE_INCLUDED
#define ENGINE_INCLUDED

#include <math.h>

#include "EngineBase.hh"

//a full software implementation for output at the scanline level
class EngineSWBase : public EngineBase
{
public:
  EngineSWBase(void);
  ~EngineSWBase(void);

  virtual void Setup(void);
  virtual void TriFace(TCoord rC1, TCoord rC2, TCoord rC3, TexC t1, TexC t2, TexC t3);

  virtual void PushTForm(TForm addTForm);
  virtual void ClearTForm(void); //sets to identity

protected:
  //void Test(void);

  //below functions call this for derived classes to render.
  virtual void PolyScanLine(unsigned sX, long startZ, unsigned eX, long endZ, unsigned yValue,
			    TexC texStart, TexC texInc, EPIXEL pixValue) = 0;

  void FlatBottomRast(int blX, int blZ, TexC blTC, int brX, int brZ, TexC brTC, int bY, int tX, int tY, int tZ, TexC tTC,
		      EPIXEL pixColor);

  void FlatTopRast(int bX, int bY, int bZ, TexC bTC, int tlX, int tlZ, TexC tlTC, int trX, int trZ, TexC trTC, int tY, 
		   EPIXEL pixColor);
  
  void LeftBrokenRast(int bX, int bY, int bZ, TexC bTC, int lBrknX, int lBrknY, int lBrknZ, TexC lBrknTC, int tX, int tY, int tZ, TexC tTC,
		      EPIXEL pixColor);

  void RightBrokenRast(int bX, int bY, int bZ, TexC bTC, int rBrknX, int rBrknY, int rBrknZ, TexC rBrknTC, int tX, int tY, int tZ, TexC tTC,
		       EPIXEL pixColor);

  TForm tForm;
  //unsigned cID; //useful for debugging if set to special texture

  inline static long RI(float in);
};

#endif //ENGINE_INCLUDED
