/*
  file created 2014
  from files created & modified in 2006 and 2009
  modified 2014
  released to the Public Domain by the author
*/

#ifndef ENGINESHADERDEVEL_INCLUDED
#define ENGINESHADERDEVEL_INCLUDED

#include <math.h>

#include "TForm.hh"

#include "EngineBase.hh"

typedef unsigned uint;
typedef signed sint;

/*
  this is the code from EngineSWBase modified to be compiled by the shader's
  compiler. After the code worked correctly, the compiled code was used with the
  cpu simulator and EngineXShaderCPU.

  After I got the breath of (pixel) life from that system, this was mostly abandoned.

  This scheme will probably be useful in the future.

  to use, see the commented out lines in EngineX.
*/

class EngineShaderDevel : public EngineBase
{
public:
  EngineShaderDevel(void);
  virtual ~EngineShaderDevel(void);

  virtual void TriFace(TCoord rC1, TCoord rC2, TCoord rC3,
		       TexC t1, TexC t2, TexC t3);

  virtual void PushTForm(TForm addTForm);
  virtual void ClearTForm(void); //sets to identity

protected:
  virtual void PolyScanLine(unsigned sX, long startZ, unsigned eX, long endZ, unsigned yValue,
			    TexC texStart, TexC texInc, EPIXEL pixValue) = 0;

  void TriFace(float rC1_x, float rC1_y, float rC1_z,
	       float rC2_x, float rC2_y, float rC2_z,
	       float rC3_x, float rC3_y, float rC3_z,
	       float t1_x, float t1_y, float t2_x, float t2_y, float t3_x, float t3_y);

  void PolyScanLine(uint sX, sint startZ, uint eX, sint endZ, uint yValue,
		    float texStart_x, float textStart_y, float texInc_x, float texInc_y, uint pixValue);


  void FlatBottomRast(sint blX, sint blZ, float blTC_x, float blTC_y,
		      sint brX, sint brZ, float brTC_x, float brTC_y,
		      sint bY, sint tX, sint tY, sint tZ, float tTC_x, float tTC_y, uint pixColor);
  
  void FlatTopRast(sint bX, sint bY, sint bZ, float bTC_x, float bTC_y,
		   sint tlX, sint tlZ, float tlTC_x, float tlTC_y,
		   sint trX, sint trZ, float trTC_x, float trTC_y, sint tY, uint pixColor);
  
  void LeftBrokenRast(sint bX, sint bY, sint bZ, float bTC_x, float bTC_y,
		      sint lBrknX, sint lBrknY, sint lBrknZ, float lBrknTC_x, float lBrknTC_y,
		      sint tX, sint tY, sint tZ, float tTC_x, float tTC_y, uint pixColor);
  
  void RightBrokenRast(sint bX, sint bY, sint bZ, float bTC_x, float bTC_y,
		       sint rBrknX, sint rBrknY, sint rBrknZ, float rBrknTC_x, float rBrknTC_y,
		       sint tX, sint tY, sint tZ, float tTC_x, float tTC_y, uint pixColor);
  
  sint RI(float in);
  
  TForm tForm;
};

#endif //ENGINESHADERDEVEL_INCLUDED
