/*
  file created 2014
  from files created & modified in 2006 and 2009
  modified 2014
  released to the Public Domain by the author
*/

#include <iostream>
#include <assert.h>

#include "EngineX.hh"

using namespace std;

EngineX::EngineX(void) :
  xImgWindow(640,480), currentTex(0),
  frameBuffer(640, 480), depthBuffer(640,480)
{}

EngineX::~EngineX(void)
{}

void EngineX::CreateRenderContext(void)
{
  if( !xImgWindow.CreateAll() )
    {
      cerr << "error opening x" << endl;
      assert(false);
    };
  
  frameBuffer.Initialize();
  depthBuffer.Initialize();
}

void EngineX::DeleteRenderContext(void)
{
  xImgWindow.DeleteAll();
}

// ****************************************

void EngineX::ClearFB(void)
{
  frameBuffer.Clear(0);
}
 
void EngineX::ClearDB(void)
{
  depthBuffer.Clear(static_cast<unsigned>(-10000000));
}

void EngineX::Flush(void)
{
  //cout << "EngineX::Flush" << endl;
  xImgWindow.UpdateWindow(frameBuffer);
}

void EngineX::UpLoadTexture(Texture &rTexture, unsigned textureID)
{
  if( textureID == 0 || textureID > 8 ) return;

  texArray[textureID-1] = rTexture;
}

void EngineX::SetCTexture(unsigned cTextureID)
{
  currentTex = cTextureID;
  /* a qnd test to see if texture data is ok
  if(currentTex == 0 || currentTex > 8) return;

  ClearFB(0);

  Texture &rTexture = texArray[currentTex - 1];
  for(unsigned cY = 0; cY < rTexture.texHeight; cY++)
    for(unsigned cX = 0; cX < rTexture.texWidth; cX++)
      {
	EPIXEL cPix = rTexture.Lookup(cX, cY);
	frameBuffer.Pixel(cX, cY) = cPix;
      };

  xImgWindow.UpdateWindow(frameBuffer);
  */
}

void EngineX::PolyScanLine(unsigned sX, long sZ, unsigned eX, long eZ, unsigned yVal,
			    TexC texStart, TexC texInc, EPIXEL pixValueIn)
{
  long deltaZ = eZ - sZ;
  long mZ = 0;
  if(sX != eX)
    mZ = deltaZ/((long)((eX - sX)));

  long cZ = sZ;
  TexC cTex(texStart);

  if( eX > 639 ) eX = 639;

  if( currentTex )
    {
      Texture &rTex = texArray[currentTex-1];
      for(unsigned ii = sX; ii <= eX; ii++)
	{
	  if( cZ > (signed)( (depthBuffer.Pixel(ii, yVal)).value) )
	    {
	      depthBuffer.Pixel(ii, yVal) = DepthPixel( cZ );
	      frameBuffer.Pixel(ii, yVal) = rTex.Lookup(cTex);
	    };
	  
	  cTex += texInc;
	  cZ += mZ;
	};
    }else
    for(unsigned ii = sX; ii <= eX; ii++)
      {
	if( cZ > (signed)( (depthBuffer.Pixel(ii, yVal)).value) )
	  {
	    depthBuffer.Pixel(ii, yVal) = DepthPixel( cZ );
	    frameBuffer.Pixel(ii, yVal) = pixValueIn;
	  };
	
	cZ += mZ;
      };

  /*
  for(unsigned ii = sX; ii <= eX; ii++)
    {
      float cDepth = sZ;
      if(ii != sX )
	cDepth += ( ((float)(eZ - sZ))/( (float)(ii - sX) ) );
      
      if( cDepth < (depthBuffer.Pixel(ii, yVal)).value ) continue;

      depthBuffer.Pixel(ii, yVal) = DepthPixel( (long)rint(cDepth) );

      frameBuffer.Pixel(ii, yVal) = pixValue;
    };
  */
}
