/*
  file created 2014
  from files created & modified in 2006 and 2009
  modified 2014
  released to the Public Domain by the author
*/

#ifndef ENGINEX_INCLUDED
#define ENGINEX_INCLUDED

#include <libImg/SimpleImg.hh>
#include <libImg/U32RGBAPixel.hh>
#include <libImg/PXMUtil.hh>
#include <libImg/XImageWindow.hh>

#include "EngineSWBase.hh"
#include "EngineShaderDevel.hh"

class DepthPixel
{
public:
  DepthPixel(void) : value(0)
  {};
  DepthPixel(long tValue) : value(tValue) {};
  DepthPixel(const DepthPixel &rhs) : value(rhs.value) {};
  ~DepthPixel(void){};

  const DepthPixel& operator=(const DepthPixel &rhs)
    {
      value = rhs.value;
      return *this;
    };

  long value;
};

/*
  so tacky... but lets me test/use EngineShaderDevel with a minimum of fuss
  changes here require a make clean; make of course
*/
#if 1
#define ENGINEX_BASE_CLASS EngineSWBase
#else
#define ENGINEX_BASE_CLASS EngineShaderDevel
#endif

class EngineX : public ENGINEX_BASE_CLASS
{
public:
  EngineX(void);
  virtual ~EngineX(void);

  virtual void CreateRenderContext(void);
  virtual void DeleteRenderContext(void);

  //engine base overloads
  virtual void ClearFB(void);
  virtual void ClearDB(void);
  virtual void UpLoadTexture(Texture &rTexture, unsigned textureID);
  virtual void SetCTexture(unsigned cTextureID);
  virtual void Flush(void);

protected:
  virtual void PolyScanLine(unsigned sX, long startZ, unsigned eX, long endZ, unsigned yValue,
			    TexC texStart, TexC texInc, EPIXEL pixValue);
protected:
  XImageWindow xImgWindow;

  unsigned currentTex; //zero is no texture is current
  Texture texArray[8];

  SimpleImg<unsigned, U32RGBAPixel> frameBuffer;
  SimpleImg<unsigned, DepthPixel> depthBuffer;
};

#endif //ENGINEX_INCLUDED
