/*
  file created 2009
  modified
  released to the Public Domain by the author
*/

#ifndef EXTOFFDATA_INCLUDED
#define EXTOFFDATA_INCLUDED

#include <list>
#include <iostream>

#include "OffData.hh"
#include "Texture.hh"

/*
  an 'extended' (hacked) off file format to allow textured files.
  I'm sure someone has done this much better.
*/


class FullCoord : public TCoord
{
public:
  FullCoord(void);
  FullCoord(float tX, float tY, float tZ, float ttexX, float ttexY);
  FullCoord(const FullCoord &rhs);
  virtual ~FullCoord(void);

  const FullCoord& operator=(const FullCoord &rhs);

  float texX, texY;
};

class ExtFaceData
{
public:
  ExtFaceData(void);
  ExtFaceData(unsigned tTexID, FullCoord tc1, FullCoord tc2, FullCoord tc3); 
  ExtFaceData(const ExtFaceData &rhs);
  ~ExtFaceData(void);

  const ExtFaceData & operator=(const ExtFaceData &rhs);

  unsigned textureID;
  //not playing any games with coordinate lookup indirection.
  FullCoord c1, c2, c3;
};

class ExtOffData
{
public:
  ExtOffData(void);
  ~ExtOffData(void);

  void ReadFullCoord(std::istream &rin, FullCoord &rCoord);

  bool LoadFile( const std::string &rFileName);

  std::list<ExtFaceData> faceList;

  std::list<Texture*> texList;
};

#endif //EXTOFFDATA_INCLUDED
