/*
  file created 2006
  modified 2009
  released to the Public Domain by the author
*/

#ifndef OFFDATA_INCLUDED
#define OFFDATA_INCLUDED

#include <iostream>
#include <string>
#include <vector>

#include "TCoord.hh"

class FaceData
{
public:
  FaceData(void);
  FaceData(unsigned tC1, unsigned tC2, unsigned tC3);
  FaceData(const FaceData &rhs);
  ~FaceData(void);

  const FaceData& operator=(const FaceData &rhs);

  unsigned c1, c2, c3;
};

class OffData
{
public:
  OffData(void);
  ~OffData(void);

  bool LoadFile(const std::string &rFileName);
  bool GetFace(unsigned num, TCoord &rOne, TCoord &rTwo, TCoord &rThree);

  void FindExtents(float &rMinX, float &rMaxX, float &rMinY, float &rMaxY,
		   float &rMinZ, float &rMaxZ);


  std::vector<TCoord> coordVec;
  std::vector<FaceData> faceVec;
};

#endif //OFFDATA_INCLUDED
