/*
  file created 2014
  from files created & modified in 2006 and 2009
  modified
  released to the Public Domain by the author
*/

#include <iostream>
#include <iomanip>

#include <unistd.h>
#include <assert.h>

#include "EPPPort.hh"
//#include "CB_EPP.hh"
#include "CB_USB.hh"
#include "CB_USB_Buffered.hh"
#include "Driver_HL.hh"
#include "DemoUnit.hh"

using namespace std;

int DoMenu(void)
{
  while(true)
    {
      cout << "enter 1 for blank" << endl;
      cout << "enter 2 for multi-color blank" << endl;
      cout << "enter 3 for lines" << endl;
      cout << "enter 4 for teapot single" << endl;
      cout << "enter 5 for teapot spin" << endl;
      cout << "enter 6 for test scanline" << endl;
      cout << "enter 7 for color test" << endl;
      cout << "enter 8 for texture demo" << endl;
      cout << "enter 9 for quit" << endl;

      int sel = 0;
      cin >> sel;
      if(sel <= 0 || sel > 9)
	{
	  cout << "print unknown selection\n\n" << endl;
	  continue;
	};

      return sel;
    };
};

TexC junkC(0.0,0.0);

int Main_Loop(CB_Base &rCB, int test_and_return = 0)
{
  Driver_HL driver(rCB);
  driver.PrintStatus();

  DemoUnit demos(driver);
  if( !demos.Init() ) return -1;

  bool done = false;
  do
    { 
      int sel = test_and_return;
      if(!test_and_return)
	sel = DoMenu();
      switch(sel)
	{
	case 1:
	  driver.Blank();
	  break;
	case 2:
	  cout << "starting red fill" << endl;
	  driver.Blank(0xC0);
	  cout << "starting green fill" << endl;
	  driver.Blank(0x38);
	  cout << "starting blue fill" << endl;
	  driver.Blank(0x07);
	  cout << "starting white fill" << endl;
	  driver.Blank(0xff);
	  cout << "starting blank" << endl;
	  driver.Blank();
	  break;
	case 3:
	  cout << "drawing lines" << endl;

	  //driver.Write_FB(640*32+32, 0xFFE01C03);
	  //driver.Write_FB(640*32+36, 0xFFE01C03);
	  //driver.Write_FB(640*32+40, 0xFFE01C03);


	  //driver.Write_FB(640*33+32, 0xE01C03FF);
	  //driver.Write_FB(640*32+36, 0xFFE01C03);
	  //driver.Write_FB(640*33+40, 0xE01C03FF);

	  //driver.DrawLine(128,0, 128,480, 0xFF);
	  //driver.DrawLine(129,0, 129,480, 0xE0);
	  //driver.DrawLine(130,0, 130,480, 0xFF);
	  //driver.DrawLine(131,0, 131,480, 0xE0);
	  //driver.DrawLine(132,0, 132,480, 0xFF);


	   driver.DrawLine(0,0, 640,480, 0xFF);
	   driver.DrawLine(640,0, 0,480, 0xC0); 
	   driver.DrawLine(0,480/2, 640,480/2, 0x38);
	   driver.DrawLine(640/2,0, 640/2,480, 0x07); 

	  //driver.DrawLine(640/2,0, 640/2,480, 0x07);
	  //driver.DrawLine(640/2+1,0, 640/2+1,480, 0x07);
	  //driver.DrawLine(640/2+2,0, 640/2+2,480, 0x07);
	  //driver.DrawLine(640/2+3,0, 640/2+3,480, 0x07);
	  //driver.DrawLine(640/2+4,0, 640/2+4,480, 0x07);	  
	  break;
	case 4:
	  driver.LoadProgram("full_shade.tbin");
	  demos.TeapotDisplaySingle(45.0);
	  break;
	case 5:
	  //driver.LoadProgram("full_shade_tmapping.tbin"); //for shits and giggles
	  driver.LoadProgram("full_shade.tbin");
	  demos.TeapotRotateAboutY();
	  break;
	case 6:
	  driver.PolyScanLine( 100, 0, 101, 0, 100, junkC,junkC, 0xFFFFFFFF);
	  driver.PolyScanLine( 100, 0, 102, 0, 102, junkC,junkC, 0xFFFFFFFF);
	  driver.PolyScanLine( 100, 0, 103, 0, 104, junkC,junkC, 0xFFFFFFFF);
	  driver.PolyScanLine( 100, 0, 104, 0, 106, junkC,junkC, 0xFFFFFFFF);
	  driver.PolyScanLine( 100, 0, 105, 0, 108, junkC,junkC, 0xFFFFFFFF);
	  //driver.PolyScanLine( 100, 0, 106, 0, 110, 0xFFFFFFFF);
	  /*
	  driver.PolyScanLine( 100, 0, 107, 0, 112, 0xFFFFFFFF);
	  driver.PolyScanLine( 100, 0, 108, 0, 114, 0xFFFFFFFF);
	  driver.PolyScanLine( 100, 0, 109, 0, 116, 0xFFFFFFFF);
	  driver.PolyScanLine( 100, 0, 110, 0, 118, 0xFFFFFFFF);
	  driver.PolyScanLine( 100, 0, 111, 0, 120, 0xFFFFFFFF);
	  driver.PolyScanLine( 100, 0, 112, 0, 122, 0xFFFFFFFF);
	  driver.PolyScanLine( 100, 0, 113, 0, 124, 0xFFFFFFFF);
	  driver.PolyScanLine( 100, 0, 114, 0, 126, 0xFFFFFFFF);
	  driver.PolyScanLine( 100, 0, 115, 0, 128, 0xFFFFFFFF);
	  driver.PolyScanLine( 100, 0, 116, 0, 130, 0xFFFFFFFF);
	  driver.PolyScanLine( 100, 0, 117, 0, 132, 0xFFFFFFFF);
	  driver.PolyScanLine( 100, 0, 118, 0, 134, 0xFFFFFFFF);
	  driver.PolyScanLine( 100, 0, 119, 0, 136, 0xFFFFFFFF);
	  driver.PolyScanLine( 100, 0, 120, 0, 138, 0xFFFFFFFF);
	  */
	  break;
	case 7:
	  //test red
	  driver.Blank(0);
	  sleep(1);
	  driver.Blank(0x40);
	  sleep(1);
	  driver.Blank(0x80);
	  sleep(1);
	  driver.Blank(0xC0);
	  sleep(1);
	  //test green
	  driver.Blank(0);
	  sleep(1);
	  driver.Blank(0x08);
	  sleep(1);
	  driver.Blank(0x10);
	  sleep(1);
	  driver.Blank(0x18);
	  sleep(1);
	  driver.Blank(0x20);
	  sleep(1);
	  driver.Blank(0x28);
	  sleep(1);
	  driver.Blank(0x30);
	  sleep(1);
	  driver.Blank(0x38);
	  sleep(1);
	  //test blue
	  driver.Blank(0);
	  sleep(1);
	  driver.Blank(0x01);
	  sleep(1);
	  driver.Blank(0x02);
	  sleep(1);
	  driver.Blank(0x03);
	  sleep(1);
	  driver.Blank(0x04);
	  sleep(1);
	  driver.Blank(0x05);
	  sleep(1);
	  driver.Blank(0x06);
	  sleep(1);
	  driver.Blank(0x07);
	  sleep(1);
	  driver.Blank(0);
	  break;
	case 8:
	  //driver.LoadProgram("full_shade.tbin"); //for shits and giggles.
	  driver.LoadProgram("full_shade_tmapping.tbin");
	  demos.TextureDemo();
	  break;
	default:
	  done = true;
	};

      if(test_and_return) done = true;
    }while(!done);

  return 0;
}

int main(void)
{
  //CB_USB cb;
  CB_USB_Buffered cb;
  cb.Init();

  cb.Test();


#if 0
  Driver_HL driver(cb);

  //driver.Blank(0xe0);
  
  driver.LoadProgram("debug_shade.tbin");
  driver.LoadDataRam(35, 0);

  driver.Write_FB(4*0, -1);
  driver.Write_FB(4*1, -2);
  driver.Write_FB(4*2, -10000);
  driver.Write_FB(4*3, -100000);
  driver.Write_FB(4*4, -1000000);
  driver.Write_FB(4*5, -10000000);
  driver.Write_FB(4*6, -100000000);
  driver.Write_FB(4*7, 20000000);

  driver.ClearHLTandReset();
  while( !driver.Halted(true) ){};

  for(unsigned ii = 0; ii < 8*4; ii+=4)
    {
      unsigned val;
      driver.Read_FB(640+ii, val);
      cout << ii << " read: " << hex << val << endl;
    };

  return 0;
#endif

#if 0
  Driver_HL driver(cb);

  driver.LoadProgram("full_shade_tmapping.tbin");
  driver.ClearFB();
  driver.ClearHLTandReset();
  while( !driver.Halted(true) ){};

 ExtOffData texturedData;
 if( !texturedData.LoadFile( "textured.off") ) 
    {
      cout << "failed to load scene from file: " << endl;
      return false;
    };

  return 0;
#endif




#if 0
  for(unsigned ii = 0; ii < 100000; ii++)
    {
      cout << "writing: " << hex << ii << dec << endl;
      cb.CB_Write(0xFE, ii);
      unsigned value = cb.CB_Read(0xFE);
      cout << hex << value << dec << endl;
      if(ii != value)
	{
	  cout << "values dont match! ii: " << ii << " " << value << dec << endl;
	};
      assert( value == ii);
    };
#endif

#if 0
  Driver_HL driver(cb);
  driver.Blank();
  //driver.Write_FB(640*32+32, 0xFFE01C03);

  driver.LoadProgram("debug_shade.tbin");
  driver.Setup();
  driver.ClearHLTandReset();
  driver.SimWaitForHalt();

  unsigned val;
  unsigned offset = (640*32 + 32);
  for(unsigned ii = 0; ii < 8*4; ii+=4)
    {
      driver.Read_FB( + ii, val);
      cout << ii << " read: " << hex << val << endl;
    };
#endif

  Main_Loop(cb);
  //Main_Loop(cb, 5); //teapot rotate
  //Main_Loop(cb, 8); //texture demo
  
  //sp.Close();
  return 0;
}

/*
int main(void)
{
  EPPPort port;
  if( !port.Initialize() ) return -1;

  if( port.CheckAndClearTimeout() )
    {
      cout << "initial timeout set" << endl;
    };
  port.WriteAddress(0);
  port.CheckAndClearTimeout();

  //port.TestDataLinkQuality();
  //return 0;

  CB_EPP cb(port);
  cb.DumpRegisters();

  //driver.WriteValue(0, 0xFF00FF33);

  //unsigned long jvalue;
  //driver.ReadValue(0, jvalue);

  // driver.PrintStatus();

  //driver.DumpRegisters();

  //unsigned long result = 0;
  //driver.ReadValue(0, result);
  //driver.DumpRegisters();

  //cout << "result: " << hex << result << dec << endl;
  //return 0;

  Main_Loop(cb);
  
  if( port.CheckAndClearTimeout() )
    {
      cout << "final timeout set" << endl;
    }else
      cout << "final timeout NOT set" << endl;

  port.CloseAll();
  return 0;
}
*/
