-- Copyright 2014
-- John Culp, All Rights Reserved

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity decoder is
  port(
    ins_dword_in : in std_logic_vector(31 downto 0);

    opp        : out std_logic_vector(6 downto 0);
    a_reg_addr : out std_logic_vector(2 downto 0);
    b_reg_addr : out std_logic_vector(2 downto 0);
    c_reg_addr : out std_logic_vector(2 downto 0);

    imm          : out std_logic_vector(15 downto 0);
    imm_sign_ext : out std_logic_vector(31 downto 0)
    );
end decoder;


architecture rtl of decoder is

  signal local_imm : std_logic_vector(15 downto 0);

begin

  opp        <= ins_dword_in(31 downto 25);
  a_reg_addr <= ins_dword_in(24 downto 22);
  b_reg_addr <= ins_dword_in(21 downto 19);
  c_reg_addr <= ins_dword_in(18 downto 16);
  local_imm  <= ins_dword_in(15 downto 0);

  imm <= local_imm;

  imm_sign_ext <= X"FFFF" & local_imm when local_imm(15) = '1' else X"0000" & local_imm;

end architecture;
