/*
  Copyright 2014
  John Culp, All Rights Reserved
*/

#include <assert.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>


/* this will become performance limiting, probably not but not right now */
#define DMA_SIZE 128

unsigned read_offset;
unsigned write_offset;

unsigned write_buffer[DMA_SIZE];
unsigned read_buffer[DMA_SIZE];

int outDMAAddr;
int outDMACount;

int out_fd = -1;
int in_fd = -1;

void DMA_Init(void)
{

  /* these should not create the files */
  out_fd = open("/home/john/tvc-all/hdl-shader/dma_server_in", O_WRONLY);
  printf("dma raw open success 1\n"); fflush(stdout);

  if(out_fd < 0)
    {
      printf("opening output out_fd failed"); fflush(stdout);
      assert(0);
    };

  in_fd = open("/home/john/tvc-all/hdl-shader/dma_server_out", O_RDONLY);  
  printf("dma open success 2\n"); fflush(stdout);
 
  if(in_fd < 0)
    {
      printf("opening input in_fd failed"); fflush(stdout);
      assert(0);
    };

}

void DMA_Close(void)
{
  close(out_fd); out_fd = -1;
  close(in_fd); in_fd = -1;
}

void DMA_In_Start(int fbAddr, int count)
{
  assert(count <= DMA_SIZE);
  read_offset = 0;

  Write_Int(out_fd, 0xF00FF00F); /* dma read command */
  Write_Int(out_fd, fbAddr);
  Write_Int(out_fd, count);

  unsigned ii;
  for(ii = 0; ii  < count; ii++)
    {
      read_buffer[ii] = Read_Int(in_fd);
    }

  read_offset = 0;//so DMA_Read_Value can use it.
}

/* right now only here for api symmetry */
void DMA_In_Finish(void)
{}

void DMA_Out_Start(int fbAddr, int count)
{
  outDMAAddr = fbAddr;
  outDMACount = count;

  write_offset = 0;
}

void DMA_Out_Finish(void)
{
  Write_Int(out_fd, 0xF00F0FF0); /* dma write command */
  Write_Int(out_fd, outDMAAddr);
  Write_Int(out_fd, outDMACount);

  unsigned ii;

  /* write values to server */
  for(ii = 0; ii < write_offset; ii++)
    {
      Write_Int(out_fd, write_buffer[ii]);
    };

  /* don't know why this won't work.
  int res = fsync(out_fd);
  if( res < 0)
    {
      perror("fsync returned: ");
    }
  */
}

int DMA_Read_Value(void)
{
  assert(read_offset < DMA_SIZE);

  int res = read_buffer[read_offset];
  read_offset = read_offset + 1;

  return res;
}

void DMA_Write_Value(int new_value)
{
  assert(write_offset < DMA_SIZE);

  write_buffer[write_offset] = new_value;
  write_offset = write_offset + 1;
}

