/*
  Copyright 2014
  John Culp, All Rights Reserved
*/

#include <assert.h>

#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/select.h>
#include <errno.h>

#include "dma_io_shared.h"

void Write_Int(int fd, unsigned value)
{
  fd_set writeSet;
  unsigned start_offset = 0;

  while(1)
    {
      int res = write(fd, ((void*)&value) + start_offset, 4-start_offset);
      if(res < 0 && errno == EINTR ) continue;
      if( res < 0 )
	{
	  printf("write failure");  fflush(stdout);
	};

      start_offset += res;
      if(res == 0)
	{
	  FD_ZERO(&writeSet);
	  FD_SET(fd, &writeSet);
	  int selres = select(fd+1, 0, &writeSet, 0, 0);
	  if( selres < 0 && errno != EINTR)
	    {
	      printf("select error on write");  fflush(stdout);
	      assert(0);
	    };
	};
      if(start_offset == 4) break;
    };
}

unsigned Read_Int(int fd)
{
 fd_set readSet;

  unsigned value;
  unsigned start_offset = 0;

  while(1)
    {
      int res = read(fd, ((void*)&value)+ start_offset, 4-start_offset);
      if( res < 0 && errno == EINTR) continue;

      if(res < 0)
	{
	  printf("read failure");  fflush(stdout);
	  assert(0);
	};
      start_offset += res;

      if(read == 0)
	{
	  FD_ZERO(&readSet);
	  FD_SET(fd, &readSet);
	  int selRes = select(fd+1, &readSet, 0, 0, 0);
	  if(selRes < 0 && errno != EINTR)
	    {
	      printf("select error on read");  fflush(stdout);
	      assert(0);
	    };
	};

      if(start_offset == 4) break;
    };

  return value;
}
