/*
  Copyright 2014
  John Culp, All Rights Reserved
*/

#include <assert.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>

#include "dma_io.h"

int main(void)
{
  printf("hello world\n"); fflush(stdout);

  DMA_Init();

  printf("starting...\n");

  DMA_Out_Start(0, 10);
  unsigned ii;
  for(ii = 0; ii < 10; ii++)
    {
      DMA_Write_Value(ii);
    };
  DMA_Out_Finish();

  DMA_In_Start(0, 10);
  for(ii = 0; ii < 10; ii++)
    {
      printf("read value: %d\n", DMA_Read_Value()); fflush(stdout);
    };
  DMA_In_Finish();

  unsigned jj = 0;
  unsigned bs = 8;
  for(jj = 0; jj < 640*480; jj+= bs)
    { 
      DMA_Out_Start(jj, bs);
      unsigned ii;
      for(ii = 0; ii < bs; ii++)
	{
	  DMA_Write_Value(0xFFFF0000);
	};
      DMA_Out_Finish();
    };

  DMA_Close();

  return 0;
};
