-- Copyright 2014
-- John Culp, All Rights Reserved

library ieee;
use ieee.std_logic_1164.all;

package shader_pack is

    component shader_meta_block is
    port(
      clock : in std_logic;
      reset : in std_logic;

      cmd_bus_data_in  : in  std_logic_vector(31 downto 0);
      cmd_bus_data_out : out std_logic_vector(31 downto 0);
      cmd_bus_addr     : in  std_logic_vector(7 downto 0);
      cmd_bus_wr       : in  std_logic;
      cmd_bus_strobe   : in  std_logic;

      mu_bus_address : in    std_logic_vector(1 downto 0);
      mu_bus_data    : inout std_logic_vector(31 downto 0);
      mu_bus_write   : in    std_logic;
      mu_bus_strobe  : in    std_logic;
      mu_cpu_dma_irq : out   std_logic;
      mu_cpu_dma_sel : in    std_logic
      );
  end component;

end;  --package
