-- Copyright 2010,2014
-- John Culp, All Rights Reserved

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

use std.textio.all;
use ieee.std_logic_textio.all;

entity std_reg is
  generic (
    REG_ADDR : std_logic_vector(2 downto 0)  -- address we will react to
    );

  port(
    clock : in std_logic;
    --reset : in std_logic; --hack. not sure if I want to reset...

    a_out_port : out std_logic_vector(31 downto 0);
    b_out_port : out std_logic_vector(31 downto 0);

    do_write       : in std_logic;
    reg_write_addr : in std_logic_vector(2 downto 0);
    c_in_port      : in std_logic_vector(31 downto 0)
    );
end std_reg;


architecture rtl of std_reg is
  signal reg_contents : std_logic_vector(31 downto 0) := X"0000_0000";

begin

  a_out_port <= reg_contents;
  b_out_port <= reg_contents;

  process(clock)
    variable out_line : line;
  begin
    if rising_edge(clock) and do_write = '1' and REG_ADDR = reg_write_addr then
      reg_contents <= c_in_port;
      
      --write(out_line, string'("SET "));
      --case REG_ADDR is
      --  when "000" =>
      --    write(out_line, string'("A"));
      --  when "001" =>
      --    write(out_line, string'("B"));
      --  when "010" =>
      --    write(out_line, string'("C"));
      --  when "011" =>
      --    write(out_line, string'("D"));
      --  when "100" =>
      --    write(out_line, string'("E"));
      --  when "101" =>
      --    write(out_line, string'("F"));
      --  when "110" =>
      --    write(out_line, string'("G"));
      --  when "111" =>
      --    write(out_line, string'("H"));
      --  when others =>
      --    assert false severity failure;
      --end case;
      --write(out_line, string'(" "));
      --hwrite(out_line, c_in_port);
      --writeline(output, out_line);

    end if;
  end process;

end architecture;
