-- Create Date:    15:46:11 07/10/2010 
-- modified 2014
-- released to the Public Domain by the author

library IEEE;
use IEEE.STD_LOGIC_1164.all;

entity reset_sync is
  generic (init_state : std_logic := '1');
  port (clock : in  std_logic;
         di   : in  std_logic;
         do   : out std_logic);
end reset_sync;

architecture Behavioral of reset_sync is

  signal state_0 : std_logic := init_state;
  signal state_1 : std_logic := init_state;
  signal state_2 : std_logic := init_state;
  signal state_3 : std_logic := init_state;

begin

  main : process(clock) is
  begin
    if clock'event and clock = '1' then
      do      <= state_3;
      state_3 <= state_2;
      state_2 <= state_1;
      state_1 <= state_0;
      state_0 <= di;
    end if;
  end process;

end Behavioral;

