-- Create Date:    21:18:10 02/10/2009
-- modified 2014
-- released to the Public Domain by the author

library IEEE;
use IEEE.STD_LOGIC_1164.all;


entity std_sync is
  generic (init_state : std_logic := '0');
  port (
    sig_in  : in  std_logic;
    sig_out : out std_logic;

    clock : in std_logic;
    reset : in std_logic
    );
end std_sync;

architecture Behavioral of std_sync is

  signal istate_1 : std_logic;
  signal istate_2 : std_logic;
  
begin

  process(clock)
  begin
    if clock = '1' and clock'event then
      if reset = '1' then
        istate_1 <= init_state;
        istate_2 <= init_state;
        sig_out  <= init_state;
      else
        sig_out  <= istate_2;
        istate_2 <= istate_1;
        istate_1 <= sig_in;
      end if;
    end if;
  end process;
  
end Behavioral;

