--file created 2014
--modified
--released to the Public Domain by the author

library ieee;
use ieee.std_logic_1164.all;

package tvc_tb_pack is

  component spi_master is
    port(
      signal spi_clk        : in  std_logic;
      signal reset          : in  std_logic;
      signal spi_busy       : out std_logic;
      signal spi_dout       : in  std_logic_vector(47 downto 0);
      signal spi_din        : out std_logic_vector(47 downto 0);
      signal spi_cmd_strobe : in  std_logic;
      signal SPI_CS         : out std_logic;
      signal MOSI           : out std_logic;
      signal MISO           : in  std_logic
      );
  end component;

  component usb_master is
    port(
      clk              : in    std_logic;
      reset            : in    std_logic;
      cmd_wr_strobe    : in    std_logic;
      cmd_rd_strobe    : in    std_logic;
      cb_address       : in    std_logic_vector(7 downto 0);
      cb_data_to_write : in    std_logic_vector(31 downto 0);
      cb_read_data     : out   std_logic_vector(31 downto 0);
      usb_busy         : out   std_logic;
      usb_fd           : inout std_logic_vector(7 downto 0);
      usb_faddr        : in    std_logic_vector(1 downto 0);
      usb_slrd         : in    std_logic;
      usb_slwr         : in    std_logic;
      usb_sloe         : in    std_logic;
      usb_slcs         : in    std_logic;
      usb_int0         : in    std_logic;
      usb_pktend       : in    std_logic;
      usb_flaga        : out   std_logic;
      usb_flagb        : out   std_logic;
      usb_flagc        : out   std_logic;
      usb_ifclk        : out   std_logic
      );
  end component;

  component tvc_imp_spi is
    port (
      tvc_clock     : in    std_logic;
      tvc_reset_in  : in    std_logic;
      tvc_reset_out : out   std_logic;
      disp1_vgaR    : out   std_logic_vector(2 downto 0);
      disp1_vgaG    : out   std_logic_vector(2 downto 0);
      disp1_vgaB    : out   std_logic_vector(2 downto 1);
      disp1_hSync   : out   std_logic;
      disp1_vSync   : out   std_logic;
      spi_cs        : in    std_logic;
      spi_sck       : in    std_logic;
      spi_mosi      : in    std_logic;
      spi_miso      : out   std_logic;
      mem_addr      : out   std_logic_vector(22 downto 0);
      nx_ram_clk    : out   std_logic;
      nx_ram_adv_n  : out   std_logic;
      nx_ram_cre    : out   std_logic;
      nx_ram_ce_n   : out   std_logic;
      nx_ram_oe_n   : out   std_logic;
      nx_ram_we_n   : out   std_logic;
      nx_ram_lb_n   : out   std_logic;
      nx_ram_ub_n   : out   std_logic;
      nx_ram_wait   : in    std_logic;
      mem_dq        : inout std_logic_vector(15 downto 0)
      );
  end component;

  component tvc_imp_usb is
    port (
      tvc_clock     : in    std_logic;
      tvc_reset_in  : in    std_logic;
      tvc_reset_out : out   std_logic;
      led_out_0     : out   std_logic;
      disp1_vgaR    : out   std_logic_vector(2 downto 0);
      disp1_vgaG    : out   std_logic_vector(2 downto 0);
      disp1_vgaB    : out   std_logic_vector(2 downto 1);
      disp1_hSync   : out   std_logic;
      disp1_vSync   : out   std_logic;
      usb_fdata     : inout std_logic_vector(7 downto 0);
      usb_faddr     : out   std_logic_vector(1 downto 0);
      usb_slrd      : out   std_logic;
      usb_slwr      : out   std_logic;
      usb_sloe      : out   std_logic;
      usb_slcs      : out   std_logic;
      usb_int0      : out   std_logic;
      usb_pktend    : out   std_logic;
      usb_flaga     : in    std_logic;
      usb_flagb     : in    std_logic;
      usb_flagc     : in    std_logic;
      usb_ifclk     : in    std_logic;
      mem_addr      : out   std_logic_vector(23 downto 1);
      nx_ram_clk    : out   std_logic;
      nx_ram_adv_n  : out   std_logic;
      nx_ram_cre    : out   std_logic;
      nx_ram_ce_n   : out   std_logic;
      nx_ram_oe_n   : out   std_logic;
      nx_ram_we_n   : out   std_logic;
      nx_ram_lb_n   : out   std_logic;
      nx_ram_ub_n   : out   std_logic;
      nx_ram_wait   : in    std_logic;
      mem_dq        : inout std_logic_vector(15 downto 0)
      );
  end component;

end package;
