/*
  Copyright 2014
  John Culp, All Rights Reserved
*/

mem_block 0
{ 
  float rC1_x;
  float rC1_y;
  float rC1_z;
  float rC2_x;
  float rC2_y;
  float rC2_z;
  float rC3_x;
  float rC3_y;
  float rC3_z;
  float t1_x;
  float t1_y;
  float t2_x;
  float t2_y;
  float t3_x;
  float t3_y;
  sint cTextureID;
  sint texStart;
  sint texSize;
  float xf11;
  float xf12;
  float xf13;
  float xf14;
  float xf21;
  float xf22;
  float xf23;
  float xf24;
  float xf31;
  float xf32;
  float xf33;
  float xf34;
  float xf41;
  float xf42;
  float xf43;
  float xf44;
  sint buffWidth;
  sint pPixBuffer;
  sint pDepthBuffer;
  sint host_command;
  sint host_argument; /*number of polygons; or pixel value */
};

#define HC_POLY 1
#define HC_CLEAR_FB 2
#define HC_CLEAR_DB 3

#define PIX_BUFF_SIZE 16

/* global local variables (if that makes any sense) */
mem_block 40
{
  float xfr_x; /* transform result */
  float xfr_y; /* transform result */
  float xfr_z; /* transform result */
  uint pixDMA[PIX_BUFF_SIZE];
  sint depthDMA[PIX_BUFF_SIZE];
  sint texDMA[2];
};

/* polygon buffer */
/* is assumed to have space for 16 polygons + texture */
/* 256 locations*/

mem_block 100
{
  float d_buffer[256]; /* much cleaner */
  /*
  float c1_x_1;
  float c1_y_1;
  float c1_z_1;
  float c2_x_1;
  float c2_y_1;
  float c2_z_1;
  float c3_x_1;
  float c3_y_1;
  float c3_z_1;
  float t1_x_1;
  float t1_y_1;
  float t2_x_1;
  float t2_y_1;
  float t3_x_1;
  float t3_y_1;
  sint tex_id_1;

  float c1_x_2;
  float c1_y_2;
  float c1_z_2;
  float c2_x_2;
  float c2_y_2;
  float c2_z_2;
  float c3_x_2;
  float c3_y_2;
  float c3_z_2;
  float t1_x_2;
  float t1_y_2;
  float t2_x_2;
  float t2_y_2;
  float t3_x_2;
  float t3_y_2;
  sint tex_id_2;
  */
};

mem_block 65520
{
uint dma0_sd_addr;
uint dma0_fb_addr;
uint dma1_sd_addr;
uint dma1_fb_addr;
uint dma2_sd_addr;
uint dma2_fb_addr;
uint dma3_sd_addr;
uint dma3_fb_addr;
uint dma_cmd;
};

void main(void)
{
  sint blah = 1;  /* compiler bug without this line... */

  /*
  if( once != 1 )
    {
      ClearFB(pDepthBuffer, 0-10000000);
      ClearFB(pPixBuffer, 65535);
      once = 1;
    };
  */

  /*
    if you look at the DMA'ed depth buffer values, this shows a problem.
    The Z values interpolate from 10 to 0 instead of 10 to -10
  float jjZ = 0.0-10.0;
  sint jeZ = RI(jjZ);
  PolyScanLine(10, 10, 18, jeZ, 10, 0.0, 0.0, 0.0, 0.0, 65535);
  return;
  */

#if 1
  if( host_command == HC_POLY )
    {
      sint c_poly = 0;
      /*
	does it make sense to do sanity checks here?
	if( host_argument > 16) host_argument = 16;
	probably not.
      */
      while(c_poly < host_argument)
	{
	  sint bo = c_poly*16;
	  
	  rC1_x = d_buffer[bo + 0];
	  rC1_y = d_buffer[bo + 1];
	  rC1_z = d_buffer[bo + 2];
	  rC2_x = d_buffer[bo + 3];
	  rC2_y = d_buffer[bo + 4];
	  rC2_z = d_buffer[bo + 5];
	  rC3_x = d_buffer[bo + 6];
	  rC3_y = d_buffer[bo + 7];
	  rC3_z = d_buffer[bo + 8];
	  t1_x  = d_buffer[bo + 9];
	  t1_y  = d_buffer[bo + 10];
	  t2_x  = d_buffer[bo + 11];
	  t2_y  = d_buffer[bo + 12];
	  t3_x  = d_buffer[bo + 13];
	  t3_y  = d_buffer[bo + 14];
	  cTextureID = d_buffer[bo + 15];

	  ProcPoly();
	  c_poly = c_poly+1;
	};
      return;
    };

  if( host_command == HC_CLEAR_FB )
    {
#if (PIX_BUFF_SIZE == 8)
      ClearFB(pPixBuffer, 9600, host_argument);
#endif

#if (PIX_BUFF_SIZE == 16)
      ClearFB(pPixBuffer, 4800, host_argument);
#endif
      return;
    };

  if( host_command == HC_CLEAR_DB )
    {
#if (PIX_BUFF_SIZE == 8)
      ClearFB(pDepthBuffer, 38400, host_argument);
#endif

#if (PIX_BUFF_SIZE == 16)
      ClearFB(pDepthBuffer, 19200, host_argument);
#endif
      return;
    };

  return; /* unknown command */
#else
  ProcPoly();
#endif
}

void ProcPoly(void)
{
  sint blah = 1;

  TForm(rC1_x, rC1_y, rC1_z);
  rC1_x = xfr_x;
  rC1_y = xfr_y;
  rC1_z = xfr_z;

  TForm(rC2_x, rC2_y, rC2_z);
  rC2_x = xfr_x;
  rC2_y = xfr_y;
  rC2_z = xfr_z;

  TForm(rC3_x, rC3_y, rC3_z);
  rC3_x = xfr_x;
  rC3_y = xfr_y;
  rC3_z = xfr_z;

  float v1_x = rC2_x - rC1_x;
  float v1_y = rC2_y - rC1_y;
  float v1_z = rC2_z - rC1_z;

  float v2_x = rC3_x - rC1_x;
  float v2_y = rC3_y - rC1_y;
  float v2_z = rC3_z - rC1_z;

  float normal_x = (v1_y*v2_z) - (v1_z*v2_y);
  float normal_y = (v1_z*v2_x) - (v1_x*v2_z);
  float normal_z = (v1_x*v2_y) - (v1_y*v2_x);

  float mag = j_sqrt( (normal_x*normal_x) + (normal_y*normal_y) + (normal_z*normal_z));
  float invMag = 1.00/mag;

  normal_x = normal_x*invMag;
  normal_y = normal_y*invMag;
  normal_z = normal_z*invMag;

  rC1_z = rC1_z*40.00;
  rC2_z = rC2_z*40.00;
  rC3_z = rC3_z*40.00;
 
  float lightVec_x = 0.00;
  float lightVec_y = 0.00;
  float lightVec_z = 1.00;

  float intensity =  (lightVec_x*normal_x) + (lightVec_y*normal_y) + (lightVec_z*normal_z);

  /* I'll just cheat and use the lightVec as a back face test. */
  /* terrible I don't implement fp compare */
  if( fp_is_neg(intensity) ) /*if( intensity < 0.0 ) */
    {
      return;
    };

  uint cVal = RI(intensity*255.00);
  if(cVal > 255)
    {
      cVal = 255;
    };

  /* EPIXEL color = cVal<<EPIXEL_RED_OFFSET | cVal<<EPIXEL_GREEN_OFFSET | cVal<<EPIXEL_BLUE_OFFSET; */
  uint color = (cVal<<16) | (cVal<<0);
    /*uint color = 4294967295;*/

  sint x1 = RI(rC1_x);
  sint y1 = RI(rC1_y);
  sint z1 = RI(rC1_z);

  sint x2 = RI(rC2_x);
  sint y2 = RI(rC2_y);
  sint z2 = RI(rC2_z);

  sint x3 = RI(rC3_x);
  sint y3 = RI(rC3_y);
  sint z3 = RI(rC3_z);

  /*
  cout << x1 << " " << y1 << " " << z1 << endl;
  cout << x2 << " " << y2 << " " << z2 << endl;
  cout << x3 << " " << y3 << " " << z3 << endl;
  cout << endl;
  */

  /* cout << "before: " << y1 << " " << y2 << " " << y3 << endl; */

  sint temp;
  float tTmp_x;
  float tTmp_y;

  /* sort the values according to increasing y's */
  if( (y1 >= y2) && (y1 > y3) ) /* exchanging y1 and y3 */
    {
      temp = x3; x3 = x1; x1 = temp;
      temp = y3; y3 = y1; y1 = temp;
      temp = z3; z3 = z1; z1 = temp;
      tTmp_x = t3_x; t3_x = t1_x; t1_x = tTmp_x;
      tTmp_y = t3_y; t3_y = t1_y; t1_y = tTmp_y;

      if( y1 > y2) /* exchanging old y3 and y2 */
	{
	  temp = x2; x2 = x1; x1 = temp;
	  temp = y2; y2 = y1; y1 = temp;
	  temp = z2; z2 = z1; z1 = temp;
	  tTmp_x = t2_x; t2_x = t1_x; t1_x = tTmp_x;
	  tTmp_y = t2_y; t2_y = t1_y; t1_y = tTmp_y;
	};
    }else{
      if( y1 > y2)
	{
	  temp = x2; x2 = x1; x1 = temp;
	  temp = y2; y2 = y1; y1 = temp;
	  temp = z2; z2 = z1; z1 = temp;
	  tTmp_x = t2_x; t2_x = t1_x; t1_x = tTmp_x;
	  tTmp_y = t2_y; t2_y = t1_y; t1_y = tTmp_y;
	}else{
	  if( y2 > y3)
	    {
	      temp = x2; x2 = x3; x3 = temp;
	      temp = y2; y2 = y3; y3 = temp;
	      temp = z2; z2 = z3; z3 = temp;
	      tTmp_x = t2_x; t2_x = t3_x; t3_x = tTmp_x;
	      tTmp_y = t2_y; t2_y = t3_y; t3_y = tTmp_y;
	      if(y1 > y2)
		{
		  temp = x2; x2 = x1; x1 = temp;
		  temp = y2; y2 = y1; y1 = temp;
		  temp = z2; z2 = z1; z1 = temp;
		  tTmp_x = t2_x; t2_x = t1_x; t1_x = tTmp_x;
		  tTmp_y = t2_y; t2_y = t1_y; t1_y = tTmp_y;
		};
	    };
      };
  };

  /* cout << "after: " << y1 << " " << y2 << " " << y3 << endl; */

  if( (y1 == y2) && (y2 == y3) )
    {
      return;
    };

  /*
  if( y1 > y2 || y1 > y3) assert(false);
  if( y2 > y3) assert(false);
  */

  if( y1 == y2 ) /* addr 915 in assem */
    {
      if( x1 < x2 ){
	FlatBottomRast(x1,z1,t1_x,t1_y, x2,z2,t2_x,t2_y, y1, x3,y3,z3,t3_x,t3_y, color); /* called 1063 */
      }else{
	FlatBottomRast(x2,z2,t2_x,t2_y, x1,z1,t1_x,t1_y, y1, x3,y3,z3,t3_x,t3_y, color); /* called 1075 */
      };
      return;
    };

  if( y2 == y3 )
    {
      if( x2 < x3 ){
	FlatTopRast(x1,y1,z1,t1_x,t1_y, x2,z2,t2_x,t2_y, x3,z3,t3_x,t3_y, y2, color);
      }else{
	FlatTopRast(x1,y1,z1,t1_x,t1_y, x3,z3,t3_x,t3_y, x2,z2,t2_x,t2_y, y2, color);
      };
      return;
    };

  if( (((y3-y1)*(x2-x1)) - ((y2 - y1)*(x3-x1))) > 0 )
    {
      RightBrokenRast(x1,y1,z1,t1_x,t1_y, x2,y2,z2,t2_x,t2_y, x3,y3,z3,t3_x,t3_y, color);  /* called 1472 */
      return;
    };


  /* cout << "left broken rast " << endl; */
  LeftBrokenRast(x1,y1,z1,t1_x,t1_y, x2,y2,z2,t2_x,t2_y, x3,y3,z3,t3_x,t3_y, color);
}

/* be careful. num_strides is blocks of 8 fb dwords or 32 bytes */
/* offset is in dwords, not bytes */

void ClearFB(uint offset, uint num_strides, uint pixValue)
{
  sint ii;
  for(ii = 0; ii < PIX_BUFF_SIZE; ii = ii + 1; )
    {
      pixDMA[ii] = pixValue;
    };

  uint cmd = (PIX_BUFF_SIZE)<<16;

  for(ii = 0; ii < num_strides; ii = ii + 1;)
    {
      sint junk = ii*PIX_BUFF_SIZE;
      sint addr = offset + junk;
      /* we wait 1st so calcs above can occur while dma busy */
      DMA_Wait();
      dma0_sd_addr = cmd | (&pixDMA);
      dma0_fb_addr = addr;
      dma_cmd = 1;
    };

  /* we wait here to be sure unit idle before going to another function */
  DMA_Wait();
}

/* leaves results in xfr_x, xfr_y xfr_z */
void TForm(float in_x, float in_y, float in_z)
{
  sint blah = 1;  /* compiler bug without this line... */

  xfr_x = (xf11*in_x) + (xf12*in_y) + (xf13*in_z) + xf14;
  xfr_y = (xf21*in_x) + (xf22*in_y) + (xf23*in_z) + xf24;
  xfr_z = (xf31*in_x) + (xf32*in_y) + (xf33*in_z) + xf34;
}

sint RI(float in)
{
  return (sint)(in+0.5);
}

float j_sqrt(float in)
{
  float lb = 0;
  float hb = in;
  sint ii;
  for(ii = 0; ii < 16; ii = ii+1;)
    {
      float guess = 0.5*(lb+hb);
      float res = guess*guess;

      if( fp_is_pos(res-in) ){ /*if( res > in) want this but no fp compare yet */
	hb = guess;
      }else{
	lb = guess;
      };

    };

  return 0.5*(lb+hb);
}

void FlatBottomRast(sint blX, sint blZ, float blTC_x, float blTC_y,
		    sint brX, sint brZ, float brTC_x, float brTC_y,
		    sint bY, sint tX, sint tY, sint tZ, float tTC_x, float tTC_y, uint pixColor) /*1442*/
{
  sint junk = 0;

#ifdef TEX_GEN
  float scale = 1.00/((float)(tY - bY));

  float leftTCInc_x = scale*(tTC_x - blTC_x);
  float leftTCInc_y = scale*(tTC_y - blTC_y);
  float rightTCInc_x = scale*(tTC_x - brTC_x);
  float rightTCInc_y = scale*(tTC_y - brTC_y);

  float leftTC_x = blTC_x;
  float leftTC_y = blTC_y;
  float rightTC_x = brTC_x;
  float rightTC_y = brTC_y;
#else
  float leftTC_x = 0.0;
  float leftTC_y = 0.0;
#endif
  
  sint cY;
  sint startX;
  sint endX;
  sint startZ;
  sint endZ;

  for(cY = bY; cY < tY; cY = cY + 1;)
    {
      startX = blX + RI( ( ((float)(cY - bY))/((float)(tY - bY)) )*((float)(tX - blX)) );
      endX =  brX + RI( (((float)(cY - bY))/((float)(tY - bY)))*((float)(tX - brX)) );

      startZ = blZ + RI( (((float)(cY - bY))/((float)(tY - bY)))*((float)(tZ - blZ)) );
      endZ =   brZ + RI( (((float)(cY - bY))/((float)(tY - bY)))*((float)(tZ - brZ)) );

      float incTC_x;
      float incTC_y;
#ifdef TEX_GEN
      scale = 1.00/((float)(endX - startX));
      incTC_x = scale*(rightTC_x - leftTC_x);
      incTC_y = scale*(rightTC_y - leftTC_y);
#endif

      PolyScanLine(startX, startZ, endX, endZ, cY, leftTC_x, leftTC_y, incTC_x, incTC_y, pixColor);

#ifdef TEX_GEN
      leftTC_x = leftTC_x + leftTCInc_x;
      leftTC_y = leftTC_y + leftTCInc_y;
      rightTC_x = rightTC_x + rightTCInc_x;
      rightTC_y = rightTC_y + rightTCInc_y;
#endif
    };
}

void FlatTopRast(sint bX, sint bY, sint bZ, float bTC_x, float bTC_y,
		  sint tlX, sint tlZ, float tlTC_x, float tlTC_y,
		  sint trX, sint trZ, float trTC_x, float trTC_y, sint tY, uint pixColor)
{
  sint junk = 0;

#ifdef TEX_GEN
  float scale = 1.00/((float)(tY - bY));
  float leftTCInc_x = scale*(tlTC_x - bTC_x);
  float leftTCInc_y = scale*(tlTC_y - bTC_y);
  float rightTCInc_x = scale*(trTC_x - bTC_x);
  float rightTCInc_y = scale*(trTC_y - bTC_y);

  float leftTC_x = bTC_x;
  float leftTC_y = bTC_y;
  float rightTC_x = bTC_x;
  float rightTC_y = bTC_y;
#else
  float leftTC_x = 0.0;
  float leftTC_y = 0.0;
#endif

  sint cY;
  sint startX;
  sint endX;
  sint startZ;
  sint endZ;
  sint cY;
  for(cY = bY; cY < tY; cY = cY+1;)
    {
      startX = bX + RI( (((float)(cY - bY))/((float)(tY - bY)))*((float)(tlX - bX))  );
      endX   = bX + RI( (((float)(cY - bY))/((float)(tY - bY)))*((float)(trX - bX)) );

      startZ = bZ + RI( (((float)(cY - bY))/((float)(tY - bY)))*((float)(tlZ - bZ)) );
      endZ   = bZ + RI( (((float)(cY - bY))/((float)(tY - bY)))*((float)(trZ - bZ)) );

      float incTC_x;
      float incTC_y;
#ifdef TEX_GEN
      scale = 1.00/((float)(endX - startX));
      incTC_x = scale*(rightTC_x - leftTC_x);
      incTC_y = scale*(rightTC_y - leftTC_y);
#endif

      PolyScanLine(startX, startZ, endX, endZ, cY, leftTC_x, leftTC_y, incTC_x, incTC_y, pixColor);

#ifdef TEX_GEN
      leftTC_x = leftTC_x + leftTCInc_x;
      leftTC_y = leftTC_y + leftTCInc_y;
      rightTC_x = rightTC_x + rightTCInc_x;
      rightTC_y = rightTC_y + rightTCInc_y;
#endif
   };
}

void LeftBrokenRast(sint bX, sint bY, sint bZ, float bTC_x, float bTC_y,
		    sint lBrknX, sint lBrknY, sint lBrknZ, float lBrknTC_x, float lBrknTC_y,
		    sint tX, sint tY, sint tZ, float tTC_x, float tTC_y, uint pixColor)
{
  sint junk = 0;

#ifdef TEX_GEN
  float scale = 1.00/((float)(lBrknY - bY));
  float leftTCInc_x = scale*(lBrknTC_x - bTC_x);
  float leftTCInc_y = scale*(lBrknTC_y - bTC_y);

  scale = 1.00/((float)(tY-bY));
  float rightTCInc_x = scale*(tTC_x - bTC_x);
  float rightTCInc_y = scale*(tTC_y - bTC_y);
#endif

  float leftTC_x = bTC_x;
  float leftTC_y = bTC_y;

  float rightTC_x = bTC_x;
  float rightTC_y = bTC_y;

  sint cY;
  sint startX;
  sint endX;
  sint startZ;
  sint endZ;
  float incTC_x;
  float incTC_y;

  for(cY = bY; cY < lBrknY; cY = cY + 1;)
    {
      startX = bX + RI( (((float)(cY - bY))/((float)(lBrknY - bY)))*((float)(lBrknX - bX)) );
      endX   = bX + RI( (((float)(cY - bY))/((float)(tY - bY)))*((float)(tX - bX)) );

      startZ = bZ + RI( (((float)(cY - bY))/((float)(lBrknY - bY)))*((float)(lBrknZ - bZ)) );
      endZ   = bZ + RI( (((float)(cY - bY))/((float)(tY - bY)))*((float)(tZ - bZ)) );
 
#ifdef TEX_GEN
      scale = 1.00/((float)(endX - startX));
      incTC_x = scale*(rightTC_x - leftTC_x);
      incTC_y = scale*(rightTC_y - leftTC_y);
#endif

      PolyScanLine(startX, startZ, endX, endZ, cY, leftTC_x, leftTC_y, incTC_x, incTC_y, pixColor);

#ifdef TEX_GEN
      leftTC_x = leftTC_x + leftTCInc_x;
      leftTC_y = leftTC_y + leftTCInc_y;
      rightTC_x = rightTC_x + rightTCInc_x;
      rightTC_y = rightTC_y + rightTCInc_y;
#endif
    };

#ifdef TEX_GEN
  leftTC_x = lBrknTC_x;
  leftTC_y = lBrknTC_y;
  scale = 1.00/((float)(tY - lBrknY));
  leftTCInc_x = scale*(tTC_x - lBrknTC_x);
  leftTCInc_y = scale*(tTC_y - lBrknTC_y);
#endif

  for(cY = lBrknY; cY < tY; cY = cY+1;)
    {
      startX = lBrknX + RI( (((float)(cY - lBrknY))/((float)(tY - lBrknY)))*((float)(tX - lBrknX)) );
      endX   = bX + RI( (((float)(cY - bY))/((float)(tY - bY)))*((float)(tX - bX)) );

      startZ = lBrknZ + RI( (((float)(cY - lBrknY))/((float)(tY - lBrknY)))*((float)(tZ - lBrknZ)) );
      endZ   = bZ + RI( (((float)(cY - bY))/((float)(tY - bY)))*((float)(tZ - bZ)) );

#ifdef TEX_GEN
      scale = 1.00/((float)(endX - startX));
      incTC_x = scale*(rightTC_x - leftTC_x);
      incTC_y = scale*(rightTC_y - leftTC_y);
#endif

      PolyScanLine(startX, startZ, endX, endZ, cY, leftTC_x, leftTC_y, incTC_x, incTC_y, pixColor);

#ifdef TEX_GEN
      leftTC_x  = leftTC_x + leftTCInc_x;
      leftTC_y  = leftTC_y + leftTCInc_y;
      rightTC_x = rightTC_x + rightTCInc_x;
      rightTC_y = rightTC_y + rightTCInc_y;
#endif
    };
}

void RightBrokenRast(sint bX, sint bY, sint bZ, float bTC_x, float bTC_y,
		     sint rBrknX, sint rBrknY, sint rBrknZ, float rBrknTC_x, float rBrknTC_y,
		     sint tX, sint tY, sint tZ, float tTC_x, float tTC_y, uint pixColor)
{
  sint junk = 0;

#ifdef TEX_GEN
  float leftTCInc_x  = (1.00/(float)(tY-bY) )*(tTC_x - bTC_x);
  float leftTCInc_y  = (1.00/(float)(tY-bY) )*(tTC_y - bTC_y);
  float rightTCInc_x = (1.00/(float)(rBrknY - bY) )*(rBrknTC_x - bTC_x);
  float rightTCInc_y = (1.00/(float)(rBrknY - bY) )*(rBrknTC_y - bTC_y);
#endif

  float leftTC_x  = bTC_x;
  float leftTC_y  = bTC_y;
  float rightTC_x = bTC_x;
  float rightTC_y = bTC_y;

  sint cY;
  sint startX;
  sint endX;
  sint startZ;
  sint endZ;
  float scale;
  float incTC_x;
  float incTC_y; 

  for(cY = bY; cY < rBrknY; cY = cY+1;)
    {
      startX = bX + RI( (((float)(cY - bY))/((float)(tY - bY)))*((float)(tX - bX))  );
      endX =   bX + RI( (((float)(cY - bY))/((float)(rBrknY - bY)))*((float)(rBrknX - bX)) );

      startZ = bZ + RI( (((float)(cY - bY))/((float)(tY - bY)))*((float)(tZ - bZ))  );
      endZ =   bZ + RI( (((float)(cY - bY))/((float)(rBrknY - bY)))*((float)(rBrknZ - bZ))  );

#ifdef TEX_GEN
      scale = 1.00/((float)(endX - startX));
      incTC_x = scale*(rightTC_x - leftTC_x);
      incTC_y = scale*(rightTC_y - leftTC_y);
#endif

      PolyScanLine(startX, startZ, endX, endZ, cY, leftTC_x, leftTC_y, incTC_x, incTC_y, pixColor);
      
#ifdef TEX_GEN
      leftTC_x = leftTC_x + leftTCInc_x;
      leftTC_y = leftTC_y + leftTCInc_y;
      rightTC_x = rightTC_x + rightTCInc_x;
      rightTC_y = rightTC_y + rightTCInc_y;
#endif
    };

#ifdef TEX_GEN
  rightTC_x = rBrknTC_x;
  rightTC_y = rBrknTC_y;
  scale = 1.00/((float)(tY - rBrknY));
  rightTCInc_x = scale*(tTC_x - rBrknTC_x);
  rightTCInc_y = scale*(tTC_y - rBrknTC_y);
#endif

  for(cY = rBrknY; cY < tY; cY=cY+1;)
    {
      startX = bX + RI( (((float)(cY - bY))/((float)(tY - bY)))*((float)(tX - bX))  );
      endX   = rBrknX + RI( (((float)(cY - rBrknY))/((float)(tY - rBrknY)))*((float)(tX - rBrknX)) );

      startZ = bZ + RI( (((float)(cY - bY))/((float)(tY - bY)))*((float)(tZ - bZ))  );
      endZ   = rBrknZ + RI( (((float)(cY - rBrknY))/((float)(tY - rBrknY)))*((float)(tZ - rBrknZ)) );

#ifdef TEX_GEN
      scale = 1.00/(float)(endX - startX);
      incTC_x = scale*(rightTC_x - leftTC_x);
      incTC_y = scale*(rightTC_y - leftTC_y);
#endif

      PolyScanLine(startX, startZ, endX, endZ, cY, leftTC_x, leftTC_y, incTC_x, incTC_y,  pixColor);
       
#ifdef TEX_GEN
      leftTC_x  = leftTC_x + leftTCInc_x;
      leftTC_y  = leftTC_y + leftTCInc_y;
      rightTC_x = rightTC_x + rightTCInc_x;
      rightTC_y = rightTC_y + rightTCInc_y;
#endif
   };
}

#if 0
//32 bpp. relativly sane. allas.
void PolyScanLine(sint startX, sint startZ, sint endX, sint endZ, sint yValue,
		  float texStart_x, float texStart_y, float texInc_x, float texInc_y, sint pixValueIn)
{

    /*
    compute the scanline pixel and depthbuffer start address
    pixStart = pixBuffer + 4*(buffWidth*yValue + startX)
    dbStart = depthBuffer + 4*(buffWidth*yValue + startX)
    start the dma into buffer
    */
 
  sint zInc = 0;
  
  /* this is a fixes a rare bug that occasionaly happens. */
  /* it leads to an invalid dma operation with length of FFFF */
  /* so FIXME. this test should be unnecessary */
  if( endX < startX)
    {
      return;
    };

  if(startX != endX)
    {
      zInc = RI( ((float)(endZ - startZ))/ ((float)(endX - startX)) );
    };

    sint buffOffset = (buffWidth*yValue) + startX;
    sint cPixStart = pPixBuffer + buffOffset;
    sint cDepthStart = pDepthBuffer + buffOffset;
    sint remainingPixels = endX - startX; /* num of pixels to process */
    sint cZ = startZ;
    sint delay = 0;
    float cTexX = texStart_x;
    float cTexY = texStart_y;

    while(remainingPixels)
    {
        sint cPix = 0;
	sint save_needed = 0;
        sint intervalPixels = PIX_BUFF_SIZE;
        if( remainingPixels < PIX_BUFF_SIZE )
	 {
             intervalPixels = remainingPixels;
         };

	  /* start the dma */
	  /* dma in pixel and depth buffer */
	  dma0_fb_addr = cPixStart;
	  dma1_fb_addr = cDepthStart;
	  
	  uint cmd = (intervalPixels)<<16;
	  cmd = cmd | (1<<31); /* set the read bit */
	  dma0_sd_addr = cmd | (&pixDMA);  /*hackish, but we know address are < 65535 */
	  dma1_sd_addr = cmd | (&depthDMA);
	  dma_cmd = 2; 		/*trigger 2 dma xfers */	  
	  DMA_Wait();

	  sint value_modified = 0;
	  uint ii = 0;
	  for( ii = 0; ii < intervalPixels ; ii = ii+1; )
          {
	    sint depthZ = depthDMA[ii];
	    if( cZ > depthZ )
	      {
#ifdef TEX_GEN
		if( cTextureID )
		  {
		    pixDMA[ii] = TextureLookup(cTexX, cTexY);
		  }else
		  {
		    pixDMA[ii] = pixValueIn;
		  };
#else
		pixDMA[ii] = pixValueIn;
#endif

		depthDMA[ii] = cZ;
		value_modified = 1;
	      };
#ifdef TEX_GEN
	    cTexX = cTexX + texInc_x;
	    cTexY = cTexY + texInc_y;
#endif
	    cZ = cZ + zInc;
          };

	  if( value_modified )
          { /* resave the dma buffers */
	    /* dma the results out. the addresses are already configured, just change the direction bits */
	    uint mask = ~(1<<31);
	    cmd = (cmd & mask);
	    dma0_fb_addr = cPixStart;
	    dma0_sd_addr = cmd | (&pixDMA); /* we reused dma command for maybe getting a texture can't read/modify/write*/
	    dma1_sd_addr = cmd | (&depthDMA);
	    dma_cmd = 2;   /*trigger 2 dma xfers */
	    DMA_Wait();
	  };

	  cPixStart = cPixStart + intervalPixels;
	  cDepthStart = cDepthStart + intervalPixels;
	  remainingPixels = remainingPixels - intervalPixels;
       };

}
#endif

#if 1
//8bpp. pfff. this is a bad idea.
void PolyScanLine(sint startX, sint startZ, sint endX, sint endZ, sint yValue,
		  float texStart_x, float texStart_y, float texInc_x, float texInc_y, sint pixValueIn)
{

    /*
    compute the scanline pixel and depthbuffer start address
    pixStart = pixBuffer + 4*(buffWidth*yValue + startX)
    dbStart = depthBuffer + 4*(buffWidth*yValue + startX)
    start the dma into buffer
    */
 
  sint zInc = 0;
  
  /* this is a fixes a rare bug that occasionaly happens. */
  /* it leads to an invalid dma operation with length of FFFF */
  /* so FIXME. this test should be unnecessary */
  if( endX < startX)
    {
      return;
    };

  if(startX != endX)
    {
      zInc = RI( ((float)(endZ - startZ))/ ((float)(endX - startX)) );
    };

    //frame buffer 'pointer' values are in bytes.
    sint fBuffOffset = (buffWidth*yValue) + startX;
    //hack. broken. note that pPixBuffer is in dwords. (but zero) we should fixup here to bytes.
    sint cPixStart = pPixBuffer + fBuffOffset;

    sint dBuffOffset = (buffWidth*yValue) + startX;
    sint cDepthStart = pDepthBuffer + dBuffOffset;

    sint remainingPixels = endX - startX; /* num of pixels to process */
    sint cZ = startZ;
    sint delay = 0;
    float cTexX = texStart_x;
    float cTexY = texStart_y;

    while(remainingPixels)
      {
        sint cPix = 0;
	sint save_needed = 0;
        sint intervalPixels = PIX_BUFF_SIZE;
        if( remainingPixels < PIX_BUFF_SIZE )
	  {
	    intervalPixels = remainingPixels;
	  };

	/* start the dma */
	/* dma in pixel and depth buffer */
	dma0_fb_addr = (cPixStart>>2);
	dma1_fb_addr = cDepthStart;
	/*
          ***************** BUUUUUUUUUUUUUGGGGGG!!! ****************
          we read (and write) too many pixels on the framebuffer!!!
	*/
	uint cmd = (intervalPixels)<<16;
	cmd = cmd | (1<<31); /* set the read bit */
	dma0_sd_addr = cmd | (&pixDMA);  /*hackish, but we know address are < 65535 */
	dma1_sd_addr = cmd | (&depthDMA);
	dma_cmd = 2; 		/*trigger 2 dma xfers */	  
	DMA_Wait();
	
	sint initial_byte_offset = (cPixStart&3);
	sint value_modified = 0;
	uint ii = 0;
	for( ii = 0; ii < intervalPixels ; ii = ii+1; )
          {
	    sint depthZ = depthDMA[ii];
	    if( cZ > depthZ )
	      {
		sint pix_value = pixValueIn;
#ifdef TEX_GEN
		if( cTextureID )
		  {
		    pix_value = TextureLookup(cTexX, cTexY);
		  };
#endif
		
		pix_value = ((pix_value&3758096384)>>24) | ((pix_value&14680064)>>19)  | ((pix_value&49152)>>14);
		pix_value = pix_value&255; //just a sanity saving fixup.

		sint byte_offset = initial_byte_offset + ii; //from begining of pix buffer. - may start at non-zero offset.
		sint dword_offset = byte_offset>>2;

		sint wide_value = pixDMA[ dword_offset ];
		 
		sint bottom_bits = (byte_offset&3);
		if( bottom_bits == 0){
		  wide_value = wide_value & 16777215; //0x00FFFFFF; gotta add support for hex constants to compiler!
		  wide_value = wide_value | (pix_value<<24);
		}else{
		  if( bottom_bits == 1 ){
		    wide_value = wide_value & 4278255615; //0xFF00FFFF;
		    wide_value = wide_value | (pix_value<<16);
		  }else{
		    if( bottom_bits == 2){
		      wide_value = wide_value & 4294902015; //0xFFFF00FF;
		      wide_value = wide_value | (pix_value<<8);
		    }else{ //must be 3
		      wide_value = wide_value & 4294967040; //0xFFFFFF00;
		      wide_value = wide_value | pix_value;
		    };
		  };
		};
	      
		pixDMA[ dword_offset ] = wide_value; //rewrite chunk of 4 pixels

		depthDMA[ii] = cZ;
		value_modified = 1;
	      };
#ifdef TEX_GEN
	    cTexX = cTexX + texInc_x;
	    cTexY = cTexY + texInc_y;
#endif
	    cZ = cZ + zInc;
          };

	  if( value_modified )
          { /* resave the dma buffers */
	    /* dma the results out. the addresses are already configured, just change the direction bits */
	    uint mask = ~(1<<31);
	    cmd = (cmd & mask);
	    dma0_fb_addr = (cPixStart>>2);
	    dma0_sd_addr = cmd | (&pixDMA); /* we reused dma command for maybe getting a texture can't read/modify/write*/
	    dma1_fb_addr = cDepthStart; /* should not need to be done */
	    dma1_sd_addr = cmd | (&depthDMA);
	    dma_cmd = 2;   /*trigger 2 dma xfers */
	    DMA_Wait();
	  };

	  cPixStart = cPixStart + intervalPixels;
	  cDepthStart = cDepthStart + intervalPixels;
	  remainingPixels = remainingPixels - intervalPixels;
       };

    /* need shaddow dma register first DMA_Wait(); */ /* make sure idle before return */
}

#endif


#ifdef TEX_GEN
sint TextureLookup(float fTexX, float fTexY)
{
  sint errorVal = (255)<<8;
   
  sint texX = RI(fTexX*255.0);
  sint texY = RI(fTexY*255.0);
  if(texX < 0)
    {
      return errorVal;
      texX = 0;
    };

  if(texX > 255)
    {
      return errorVal;
      texX = 255;
    };

  if(texY < 0)
    {
      return errorVal;
      texY = 0;
    };

  if(texY > 255)
    {
      return errorVal;
      texY = 255;
    };

  dma0_fb_addr = texStart + ((cTextureID-1)*texSize) + (texY*256) + texX;
	  
  uint cmd = (1)<<16; /* read only one dword */
  cmd = cmd | (1<<31); /* set the read bit */
  dma0_sd_addr = cmd | (&texDMA);  /*hackish, but we know address are < 65535 */
  dma_cmd = 1; 		/*trigger single dma xfer */	  
  DMA_Wait(); /* can't do this in the background */

  return texDMA[0]; /*(255)<<24;*/ /*texDMA; */
} 
#endif

void DMA_Wait(void)
{
  /* should wait a tick, but we did more than that in CALL */
  while(dma_cmd){ sint delay = 1; };
}
