/*
  Copyright 2014
  John Culp, All Rights Reserved
*/

mem_block 0
{ 
sint startX;
sint startZ;
sint endX;
sint endZ;
sint yValue;
sint texStartX;
sint texStartY;
sint texIncX;
sint texIncY;
sint pixValueIn;
sint zInc;
sint buffWidth;
sint pPixBuffer;
sint pDepthBuffer;
uint pixDMA[8];
sint depthDMA[8];
};

mem_block 504
{
uint dma0_fb_addr;
uint dma0_sd_addr;
uint dma1_fb_addr;
uint dma1_sd_addr;
uint dma2_fb_addr;
uint dma2_sd_addr;
uint dma3_fb_addr;
uint dma3_sd_addr;
uint dma_cmd;
};

void main(void)
{
    /*
    compute the scanline pixel and depthbuffer start address
    pixStart = pixBuffer + 4*(buffWidth*yValue + startX)
    dbStart = depthBuffer + 4*(buffWidth*yValue + startX)
    start the dma into buffer
    */
  /* float myNum = (float)3; */
  sint buffOffset = (buffWidth*yValue) + startX;
    sint cPixStart = pPixBuffer + buffOffset;
    sint cDepthStart = pDepthBuffer + buffOffset;
    sint remainingPixels = endX - startX; /* num of pixels to process */
    sint cZ = startZ;
    sint delay = 0;

    while(remainingPixels)
    {
        sint cPix = 0;
	sint save_needed = 0;
        sint intervalPixels = 8;
        if( remainingPixels < 8 )
	 {
             intervalPixels = remainingPixels;
         };

	  /* start the dma */
	  /* dma in pixel and depth buffer */
	  dma0_fb_addr = cPixStart;
	  dma1_fb_addr = cDepthStart;
	  
	  uint cmd = (intervalPixels)<<16;
	  cmd = cmd | (1<<31); /* set the read bit */
	  dma0_sd_addr = cmd | (&pixDMA);  /*hackish, but we know address are < 65535 */
	  dma1_sd_addr = cmd | (&depthDMA);
	  dma_cmd = 2; 		/*trigger 2 dma xfers */	  
	  DMA_Delay();

	  sint value_modified = 0;
	  uint ii = 0;
	  for( ii = 0; ii < intervalPixels ; ii = ii+1; )
          {
	    sint depthZ = depthDMA[ii];
	    if( cZ > depthZ )
	    {
 	      pixDMA[ii] = pixValueIn;
	      depthDMA[ii] = cZ;
	      value_modified = 1;
	    };
	    cZ = cZ + zInc;
          };

	  if( value_modified )
          { /* resave the dma buffers */
	    /* dma the results out. the addresses are already configured, just change the direction bits */
	   uint mask = ~(1<<31);
	   dma0_sd_addr = dma0_sd_addr & mask;
	   dma1_sd_addr = dma1_sd_addr & mask;
	   dma_cmd = 2; 		/*trigger 2 dma xfers */
	   DMA_Delay();
	  };

	  cPixStart = cPixStart + intervalPixels;
	  cDepthStart = cDepthStart + intervalPixels;
	  remainingPixels = remainingPixels - intervalPixels;
       };
}

void DMA_Delay(void)
{
  /* should wait a tick, but we did more than that in CALL */
  while(dma_cmd){ sint delay = 1; };
}
